package KDDCup05.termstools;

import java.io.PrintStream;
import java.io.UnsupportedEncodingException;
import java.text.DecimalFormat;
import java.util.ArrayList;

public class TermInfoNew implements Comparable<TermInfoNew>{
	
	public static enum ComparingBy{
		SCORE,
		TERM,
		HINTS,
		HINTSMINDF,
		DF
	}
	
	public double score;
	public String term;
	public int hints;
	public int hintsMinDF;
	public int DF; //einai iso me minDF sto seed query kai iso me andDF sta scrambler terms
	public ArrayList<Integer> DocIDs;
	public ArrayList<Integer> DocIDsMinDF;

	public TermInfoNew() {
		this.score = 0.0;
		this.term = "";
		this.hints = 0;
		this.hintsMinDF = 0;
		this.DF = 0;
		this.DocIDs = new ArrayList<Integer>();
		this.DocIDsMinDF = new ArrayList<Integer>();
	}
	
	public TermInfoNew(String term) {
		this.score = 0.0;
		this.term = term;
		this.hints = 0;
		this.hintsMinDF = 0;
		this.DF = 0;
		this.DocIDs = new ArrayList<Integer>();
		this.DocIDsMinDF = new ArrayList<Integer>();
	}
	
	
	public double PrivacyPrecision(){
		return (double)hintsMinDF/DF;
	}
	
	public double Recall(double df_seed){
		return (double)hintsMinDF/df_seed;
	}
	
	public double calcFb(double b, double df_seed){
		return ((1+b*b)*PrivacyPrecision()*Recall(df_seed))/((b*b*PrivacyPrecision())+Recall(df_seed));
	}
	
	public boolean PrivacyKFilter(double k){
		double p = 1.0/PrivacyPrecision();
		if(p <= k){
			return false; //to petame
		}else{
			return true;
		}
	}
	
	public boolean PrivacyLevelFilter(double level, int seedDF, int M){
		if(level < 0.0){
			if((double)this.DF <= Math.abs(level)*seedDF){
				return false; // petama
			}else{
				return true;
			}
		}else{
			if((double)this.DF/M <= level){
				return false; // petama
			}else{
				return true;
			}
		}
	}
//	
//	public double Fbeta(int docsSize)
//	{
//		double beta = 1.0;
//		double rec = Recall(docsSize);
//		double prec = Precision();
//		return (1.0+Math.pow(beta,2.0))*(prec*rec)/((Math.pow(beta,2.0))*prec+rec);
//	}
	
	public double calcMI(double df_trunc, double M){
		
		double N11 = this.hints;
		double N10 = this.DF - this.hints; // can be zero
		double N01 = df_trunc - this.hints; // can be zero
		double N00 = M - df_trunc - N10;
		double N1_ = N10 + N11;
		double N_1 = N01 + N11;
		double N0_ = N00 + N01;
		double N_0 = N00 + N10;		
 		double pc1 = df_trunc/M;
		double pc0 = 1.0 - pc1;
		double Hc = - ( pc1*(Math.log(pc1)/Math.log(2)) + pc0*(Math.log(pc0)/Math.log(2)) );
		
		double MI = (N11/M) * (Math.log((M * N11)/(N1_ * N_1))/Math.log(2));
		if(N01 > 0){
			MI += (N01/M) * (Math.log((M * N01)/(N0_ * N_1))/Math.log(2));
		}
		if(N10 > 0){
			MI += (N10/M) * (Math.log((M * N10)/(N1_ * N_0))/Math.log(2));
		}
		
		MI += (N00/M) * (Math.log((M * N00)/(N0_ * N_0))/Math.log(2));
		MI /= Hc;
		
		return MI; // if MI < 0 tote den xrhsimopoioume ton term
		// Ean einai 1.0000 tote to kanei 0.9999 (Patentes Avi)
	}
	
	public double calcDistanceMI(double df_trunc, double M){
		
		double N11 = this.hints;
		double N10 = this.DF - this.hints; // can be zero
		double N01 = df_trunc - this.hints; // can be zero
		double N00 = M - df_trunc - N10;
		double N1_ = N10 + N11;
		double N_1 = N01 + N11;
		double N0_ = N00 + N01;
		double N_0 = N00 + N10;		
 		double pc1 = df_trunc/M;
		double pc0 = 1.0 - pc1;
		double Hc = - ( pc1*(Math.log(pc1)/Math.log(2)) + pc0*(Math.log(pc0)/Math.log(2)) );
		
		double pt1 = (double)this.hints/M; 
		double pt0 = 1.0 - pt1; 
		double Ht = - ( pt1*(Math.log(pt1)/Math.log(2)) + pt0*(Math.log(pt0)/Math.log(2)) );
		
		//System.out.println(Hc+" "+Ht);
		
		double MI = (N11/M) * (Math.log((M * N11)/(N1_ * N_1))/Math.log(2));
		if(N01 > 0){
			MI += (N01/M) * (Math.log((M * N01)/(N0_ * N_1))/Math.log(2));
		}
		if(N10 > 0){
			MI += (N10/M) * (Math.log((M * N10)/(N1_ * N_0))/Math.log(2));
		}
		
		MI += (N00/M) * (Math.log((M * N00)/(N0_ * N_0))/Math.log(2));
		MI /= Math.max(Hc, Ht);
		
		return MI; // if MI < 0 tote den xrhsimopoioume ton term
		// Ean einai 1.0000 tote to kanei 0.9999 (Patentes Avi)
	}
	
	public boolean parseTermInfo(String terminfo){
		try{
			String[] values = terminfo.split(" ");
			this.score = Double.valueOf(values[0]);
			this.term = values[1];
			this.hints = Integer.valueOf(values[2]);
			this.hintsMinDF = Integer.valueOf(values[3]);
			this.DF = Integer.valueOf(values[4]);
			for(int i = 5;i<values.length;i++){
				this.DocIDs.add(Integer.valueOf(values[i]));
			}	
		}catch(Exception e){
        	System.err.println("ERROR With String Parsing:" + e.toString());
        	return false;
		}
		return true;
	}
	
	public void keepOnlyMatchesWithSeedQuery(ArrayList<Integer> good, ArrayList<Integer> goodMinDF){
		ArrayList<Integer> match = new ArrayList<Integer>();
		int find = 0;
		int findMinDF = 0;
		for (Integer x: this.DocIDs) {
			if(good.contains(x)){
				match.add(x);
				find++;
			}
			if(goodMinDF.contains(x)){
				findMinDF++;
			}
		}
		this.DocIDs = match;
		this.hints = find;
		this.hintsMinDF = findMinDF;
	}
	
	public boolean updateMatchesWithSeedQueryInDF(ArrayList<Integer> goodMinDF){
		ArrayList<Integer> match = new ArrayList<Integer>();
		int findMinDF = 0;
		for (Integer x: this.DocIDs) {
			if(goodMinDF.contains(x)){
				match.add(x);
				findMinDF++;
			}
		}
		this.DocIDs = match;
		if(this.hintsMinDF == findMinDF){
			return true;
		}else{
			return false;
		}
	}
	
	public void print(){
		DecimalFormat df = new DecimalFormat("0.0000");
		String str = "";
		str += df.format(this.score)+" ";
		str += this.term+" ";
		str += this.hints+" ";
		str += this.hintsMinDF+" ";
		str += this.DF+" ";
		for (int x : this.DocIDs) {
			str += x+" ";
		}
		
		try {
			PrintStream out = new PrintStream(System.out, true, "UTF-8");
			out.println(str);
		} catch (UnsupportedEncodingException e) {
			System.err.println("Error in encoding to UTF-8: "+e.toString());
		}
		//System.out.println(str);
	}
	
	public double[] getInstanceValues(ArrayList<Integer> good){
		double[] values = new double[good.size()];
		
		//int count =0;
		
		for(int i=0;i<values.length;i++){
			if(this.DocIDs.contains(good.get(i))){
				values[i] = 1.0/Math.sqrt(this.hints); //values[i] = 1.0;
				//count++;
			}
		}
		
		
		//for(int i=0;i<values.length;i++){
		//		values[i] = values[i]/Math.sqrt(count);
		//}
		
		return values;
	}
	
	public double[] getInstanceValuesNotNormalized(ArrayList<Integer> good){
		double[] values = new double[good.size()];
		
		for(int i=0;i<values.length;i++){
			if(this.DocIDs.contains(good.get(i))){
				values[i] = 1.0;
			}
		}
		
		return values;
	}
	
	public String toString(){
		DecimalFormat df = new DecimalFormat("0.0000");
		String str = "";
		str += df.format(this.score)+" ";
		str += this.term+" ";
		str += this.hints+" ";
		str += this.hintsMinDF+" ";
		str += this.DF+" ";
		for (int x : this.DocIDs) {
			str += x+" ";
		}
		return str;
	}
	
	public int compareTo(TermInfoNew t, ComparingBy cb){
		if(cb == ComparingBy.SCORE){
			return (new Double(this.score)).compareTo(t.score);
		}else if(cb == ComparingBy.TERM){
			return this.term.compareTo(t.term);
		}else if(cb == ComparingBy.HINTS){
			return (new Integer(this.hints)).compareTo(t.hints);
		}else if(cb == ComparingBy.HINTSMINDF){
			return (new Integer(this.hintsMinDF)).compareTo(t.hintsMinDF);
		}else if(cb == ComparingBy.DF){
			return (new Integer(this.DF)).compareTo(t.DF);
		}else{
			Integer ret = null;
			return ret;
		}
	}
	
	public int hashCode(){
		return this.term.hashCode();
	}
	
	public int compareTo(TermInfoNew t){
		//return this.term.compareTo(t.term);
		if((new Double(this.score)).compareTo(t.score) == 0){
			if((new Integer(this.hints)).compareTo(t.hints) == 0){
				return -1 * (new Integer(this.hintsMinDF)).compareTo(t.hintsMinDF);
			}else{
				return -1 * (new Integer(this.hints)).compareTo(t.hints);
			}
		}else{
			return -1 * (new Double(this.score)).compareTo(t.score);
		}	
	}
	
	public boolean eguals(Object o){ // Check only the term
		if(o instanceof TermInfoNew){
			if(((TermInfoNew)o).term.equals(this.term)){
				return true;
			}else{
				return false;
			}
		}else{
			return false;
		}
	}
	
	public Object clone(){
		TermInfoNew tt = new TermInfoNew();
		tt.score = this.score;
		tt.term = new String(this.term);
		tt.hints = this.hints;
		tt.hintsMinDF = this.hintsMinDF;
		tt.DF = this.DF;
		tt.DocIDs = (ArrayList<Integer>)this.DocIDs.clone();
		tt.DocIDsMinDF = (ArrayList<Integer>)this.DocIDsMinDF.clone();
		return tt;
	}

}
