/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package dialogs;

import finals.Finals;
import java.awt.Color;
import java.io.File;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.Hashtable;
import java.util.Random;
import org.graphstream.graph.Edge;
import org.graphstream.graph.Graph;
import org.graphstream.graph.Node;
import org.graphstream.graph.implementations.MultiGraph;
import org.graphstream.ui.swingViewer.View;
import org.graphstream.ui.swingViewer.Viewer;
import sqlite.CategorizationDataSource;
import sqlite.MySQLiteHelper;

/**
 *
 * @author drosatosgr
 */
public class GraphJFrame extends javax.swing.JFrame {

    /**
	 * 
	 */
	private static final long serialVersionUID = -9186876245560363000L;
	private Graph graph;
    private Viewer viewerG;
    private View viewG;
    private MySQLiteHelper db;
    private CategorizationDataSource cds;
    private DecimalFormat df = new DecimalFormat("#.#####");

    /**
     * Creates new form GraphJFrame
     */
    public GraphJFrame(MySQLiteHelper db) {
        this.db = db;
        cds = new CategorizationDataSource(db);
        System.setProperty("org.graphstream.ui.renderer", "org.graphstream.ui.j2dviewer.J2DGraphRenderer");
        initComponents();

        graph = new MultiGraph("User.Intention");//new AdjacencyListGraph("User.Intention"); //new MultiGraph("User.Intention");//new SingleGraph("User.Intention");

        viewerG = new Viewer(graph, Viewer.ThreadingModel.GRAPH_IN_SWING_THREAD);
        //viewerG.enableAutoLayout(new HierarchicalLayout());
        viewerG.enableAutoLayout();
        viewG = viewerG.addDefaultView(false);

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
                jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addComponent(viewG, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        jPanel1Layout.setVerticalGroup(
                jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addComponent(viewG, javax.swing.GroupLayout.DEFAULT_SIZE, 501, Short.MAX_VALUE)
        );

        jPanel1.add(viewG);

        jComboBox1.removeAllItems();
        for(int i=1; i<=Finals.topNCategories; i++){
            jComboBox1.addItem(i);
        }
        Calendar cal = Calendar.getInstance();
        cal.setTime(new Date()); 
        cal.set(Calendar.HOUR, 0);
        cal.set(Calendar.MINUTE, 0);
        cal.set(Calendar.SECOND, 0);
        cal.set(Calendar.MILLISECOND, 0);
        jDateChooser2.setDate(cal.getTime());
        cal.add(Calendar.DATE, -1);
        jDateChooser1.setDate(cal.getTime());     
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jDateChooser1 = new com.toedter.calendar.JDateChooser();
        jDateChooser2 = new com.toedter.calendar.JDateChooser();
        jButton1 = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jPanel1 = new javax.swing.JPanel();
        jToggleButton1 = new javax.swing.JToggleButton();
        jComboBox1 = new javax.swing.JComboBox();
        jLabel3 = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Graph: User Intention");
        setIconImage(Finals.putIconImage());
        setMinimumSize(new java.awt.Dimension(652, 295));

        jDateChooser1.setDateFormatString("yyyy/MM/dd");
        jDateChooser1.setName("JDateChooserFrom"); // NOI18N
        jDateChooser1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
            public void propertyChange(java.beans.PropertyChangeEvent evt) {
                jDateChooser1PropertyChange(evt);
            }
        });

        jDateChooser2.setDateFormatString("yyyy/MM/dd");
        jDateChooser2.setName("JDateChooserTo"); // NOI18N
        jDateChooser2.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
            public void propertyChange(java.beans.PropertyChangeEvent evt) {
                jDateChooser2PropertyChange(evt);
            }
        });

        jButton1.setText("Refresh");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel1.setText("From:");

        jLabel2.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel2.setText("To:");

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 504, Short.MAX_VALUE)
        );

        jToggleButton1.setText("Disable Graph AutoLayout");
        jToggleButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton1ActionPerformed(evt);
            }
        });

        jComboBox1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBox1ActionPerformed(evt);
            }
        });

        jLabel3.setText("Show Top-n Intentions:");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel1)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jDateChooser1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jLabel2)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jDateChooser2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jLabel3)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jComboBox1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 53, Short.MAX_VALUE)
                        .addComponent(jToggleButton1)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButton1)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(jLabel3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jComboBox1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(jButton1)
                        .addComponent(jToggleButton1))
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                        .addComponent(jDateChooser2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jDateChooser1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jLabel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jLabel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );

        layout.linkSize(javax.swing.SwingConstants.VERTICAL, new java.awt.Component[] {jComboBox1, jDateChooser1, jDateChooser2, jLabel1, jLabel2, jLabel3});

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jDateChooser1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_jDateChooser1PropertyChange
        if ("date".equals(evt.getPropertyName())) {
            refreshResutls();
        }
    }//GEN-LAST:event_jDateChooser1PropertyChange

    private void jDateChooser2PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_jDateChooser2PropertyChange
        if ("date".equals(evt.getPropertyName())) {
            refreshResutls();
        }
    }//GEN-LAST:event_jDateChooser2PropertyChange

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        refreshResutls();
    }//GEN-LAST:event_jButton1ActionPerformed

    private void jToggleButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton1ActionPerformed
        if (jToggleButton1.isSelected()) {
            jToggleButton1.setText("Enable Graph AutoLayout");
            viewerG.disableAutoLayout();
        } else {
            jToggleButton1.setText("Disable Graph AutoLayout");
            viewerG.enableAutoLayout();
        }
    }//GEN-LAST:event_jToggleButton1ActionPerformed

    private void jComboBox1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBox1ActionPerformed
        refreshResutls();
    }//GEN-LAST:event_jComboBox1ActionPerformed

    public void refreshResutls() {
        graph.clear();
        graph.addAttribute("ui.stylesheet", "url('file:///" + (new File(Finals.cssGraph)).getAbsolutePath() + "')");
        //graph.addAttribute("ui.quality");
        graph.addAttribute("ui.antialias");
        graph.setAutoCreate(true);
        graph.setStrict(false);

        viewerG.disableAutoLayout();
        Node user = graph.addNode("user");
        user.addAttribute("ui.label", "User Intentions");
        user.addAttribute("ui.class", "user");
        if (jDateChooser1.getDate() != null && jDateChooser2.getDate() != null) {
            Hashtable<String, Color> colors = new Hashtable<String, Color>();
            Hashtable<String, Integer> countR = new Hashtable<String, Integer>();
            Hashtable<String, Integer> countL = new Hashtable<String, Integer>();
            Random random = new Random();
            Calendar cal = Calendar.getInstance();
            cal.setTime(jDateChooser2.getDate()); 
            cal.set(Calendar.HOUR, 23);
            cal.set(Calendar.MINUTE, 59);
            cal.set(Calendar.SECOND, 59);
            cal.set(Calendar.MILLISECOND, 999);
            ArrayList<ArrayList<Object>> sel = cds.getDataForGraph(jDateChooser1.getDate(), cal.getTime(), Integer.valueOf(""+jComboBox1.getSelectedItem()));
            for (ArrayList<Object> r : sel) {

                Node root = graph.addNode("R" + r.get(0));
                root.addAttribute("ui.label", r.get(1));
                if (!colors.containsKey("R" + r.get(0))) {
                    colors.put("R" + r.get(0), new Color(random.nextFloat(),random.nextFloat(),random.nextFloat()));
                }
                if (!countR.containsKey("R" + r.get(0))) {
                    countR.put("R" + r.get(0), 1);
                } else {
                    countR.replace("R" + r.get(0), countR.get("R" + r.get(0)) + 1);
                }
                //root.addAttribute("ui.class", "root");
                root.addAttribute("ui.style", "fill-color: rgb("+colors.get("R" + r.get(0)).getRed()+","+colors.get("R" + r.get(0)).getGreen()+","+colors.get("R" + r.get(0)).getBlue()+"); size: "+(10 + 120*countR.get("R" + r.get(0))/sel.size())+"px;");
                
                Node leaf = graph.addNode("L" + r.get(2));
                leaf.addAttribute("ui.label", r.get(3));
                if (!countL.containsKey("L" + r.get(2))) {
                    countL.put("L" + r.get(2), 1);
                } else {
                    countL.replace("L" + r.get(2), countL.get("L" + r.get(2)) + 1);
                }
                //leaf.addAttribute("ui.class", "leaf");
                leaf.addAttribute("ui.style", "fill-color: rgb("+colors.get("R" + r.get(0)).getRed()+","+colors.get("R" + r.get(0)).getGreen()+","+colors.get("R" + r.get(0)).getBlue()+"); size: "+(10 + 120*countL.get("L" + r.get(2))/sel.size())+"px;");
                
                Node query = graph.addNode("Q" + r.get(5));
                query.addAttribute("ui.label", r.get(6));
                query.addAttribute("ui.class", "query");

                graph.addEdge("UR" + r.get(0), user.getId(), root.getId());//.addAttribute("layout.weight", (float)countR.get("R" + r.get(0))/sel.size());
                graph.addEdge("R" + r.get(0) + "L" + r.get(2), root.getId(), leaf.getId());//.addAttribute("layout.weight", (float)countL.get("L" + r.get(2))/sel.size());
                Edge weight = graph.addEdge("L" + r.get(2) + "Q" + r.get(5), leaf.getId(), query.getId());
                weight.setAttribute("ui.label", df.format(r.get(4)));
            }
        }
        viewerG.enableAutoLayout();
        //viewerG.enableAutoLayout(new HierarchicalLayout());
    }

//    /**
//     * @param args the command line arguments
//     */
//    public static void main(String args[]) {
//        /* Set the Nimbus look and feel */
//        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
//        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
//         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
//         */
//        try {
//            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
//                if ("Nimbus".equals(info.getName())) {
//                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
//                    break;
//                }
//            }
//        } catch (ClassNotFoundException ex) {
//            java.util.logging.Logger.getLogger(GraphJFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
//        } catch (InstantiationException ex) {
//            java.util.logging.Logger.getLogger(GraphJFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
//        } catch (IllegalAccessException ex) {
//            java.util.logging.Logger.getLogger(GraphJFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
//        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
//            java.util.logging.Logger.getLogger(GraphJFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
//        }
//        //</editor-fold>
//
//        /* Create and display the form */
//        java.awt.EventQueue.invokeLater(new Runnable() {
//            public void run() {
//                new GraphJFrame(null).setVisible(true);
//            }
//        });
//    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JComboBox jComboBox1;
    private com.toedter.calendar.JDateChooser jDateChooser1;
    private com.toedter.calendar.JDateChooser jDateChooser2;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JToggleButton jToggleButton1;
    // End of variables declaration//GEN-END:variables
}
