package ecg.afib.detector;

import java.util.ArrayList;




import ecg.dsp.tools.DigitalFilter;
import ecg.dsp.tools.MedianFilter;
import ecg.dsp.tools.StatisticalUtilities;

/**
*
* @author Andrius Solosenko, Andrius Petrenas
*/

public class AFibDetector {

	// Offline coefficients
	//static double[] b = {0.02};
	//static double[] a = {1, (-1 + b[0])};
	
	// Online coefficients
    double alfa = 0.02;
    double[] b = {Math.pow(alfa, 2)};
    double[] a = {1.0, -2*(1-alfa), Math.pow((1-alfa), 2)};
	
		
	MedianFilter mMedianFilter = null;
	
	MedianFilter mMedianFilterCurrentIntRawDiff = null;
	
	DigitalFilter mDigitalFilterExpIIR1 = null;
	DigitalFilter mDigitalFilterExpIIR2 = null;
	DigitalFilter mDigitalFilterExpIIR3 = null;
	
    StatisticalUtilities mStatisticalUtilitiesIntRawDiv = null;
    StatisticalUtilities mStatisticalUtilitiesIntMedDiv = null;
    StatisticalUtilities mStatisticalUtilitiesIntRawDiff = null; 
    
    MedianFilter mMedianFilterCurrentIntRawDiv = null;
    MedianFilter mMedianFilterCurrentIntMedDiv = null;
    	
	
	int windowLength = 8;
	
    double[] RRin        = new double[windowLength];
    double[] RRinRaw     = new double[windowLength];
    
    double[] intervalArrayRawDiff    = new double[windowLength];
    double[] intervalArrayRawDivMed  = new double[windowLength];
    double[] intervalArrayMedDivMed  = new double[windowLength];
    double[] intervalArrayRawDiffMed = new double[windowLength];

    double rrin = 0;
    double rrinRaw = 0;
    
    double currentIntervalRawDiv = 0;
    double currentIntervalMedDiv = 0;
    
    double currentIntervalRawDiff = 0;
    
    double currentIntervalRawDivMed = 0;
    double currentIntervalMedDivMed = 0;
    double currentIntervalRawDiffMed = 0;
           
    ArrayList<Double> afibDetOut = new ArrayList<Double>();
    ArrayList<Double> decision = new ArrayList<Double>();
    
    double r = 0.03;
    double nRMS;
    double nDiff;
    double nMean;
    double nDiffLP;
    double diffDivRms;
    double diffDivMean;
    double detector1thr;
    
          
    
    public double[] func_detectAF(double[] rr) {
    	
        mMedianFilterCurrentIntRawDiff = new MedianFilter();
    	
    	mMedianFilter = new MedianFilter();	
    	
        mDigitalFilterExpIIR1 = new DigitalFilter();
    	mDigitalFilterExpIIR2 = new DigitalFilter();
    	mDigitalFilterExpIIR3 = new DigitalFilter();
    	
        mStatisticalUtilitiesIntRawDiv = new StatisticalUtilities();
        mStatisticalUtilitiesIntMedDiv = new StatisticalUtilities();
        
        mStatisticalUtilitiesIntRawDiff = new StatisticalUtilities();
    	
        mMedianFilterCurrentIntRawDiv = new MedianFilter();
        mMedianFilterCurrentIntMedDiv = new MedianFilter();
    			
              		
		  for(int n = 0; n < rr.length; n++) {
			  
			  rrinRaw = rr[n];
			  
			  rrin = mMedianFilter.Median_Filter(rrinRaw, 3);
			  
	          currentIntervalRawDiv = mStatisticalUtilitiesIntRawDiv.div(rrinRaw);
	          currentIntervalMedDiv = mStatisticalUtilitiesIntMedDiv.div(rrin);
	                            
	          currentIntervalRawDivMed = mMedianFilterCurrentIntRawDiv.Median_Filter(currentIntervalRawDiv, 3);
	          currentIntervalMedDivMed = mMedianFilterCurrentIntMedDiv.Median_Filter(currentIntervalMedDiv, 3);
	          
	          currentIntervalRawDiff = mStatisticalUtilitiesIntRawDiff.diff(rrinRaw);
	          currentIntervalRawDiffMed = mMedianFilterCurrentIntRawDiff.Median_Filter(currentIntervalRawDiff, 3);
			  
			  
              if (n >= 1 && n <= windowLength) {                 	

                  System.arraycopy(RRinRaw, 1, RRinRaw, 0, windowLength - 1);
                  RRinRaw[windowLength - 1] = rrinRaw;     

                  System.arraycopy(RRin, 1, RRin, 0, windowLength - 1);
                  RRin[windowLength - 1] = rrin;   
                  
                  System.arraycopy(intervalArrayRawDiff, 1, intervalArrayRawDiff, 0, windowLength - 1);
                  intervalArrayRawDiff[windowLength - 1] = currentIntervalRawDiff;
                  
                  System.arraycopy(intervalArrayRawDivMed, 1, intervalArrayRawDivMed, 0, windowLength - 1);
                  intervalArrayRawDivMed[windowLength - 1] = currentIntervalRawDivMed;

                  System.arraycopy(intervalArrayMedDivMed, 1, intervalArrayMedDivMed, 0, windowLength - 1);
                  intervalArrayMedDivMed[windowLength - 1] = currentIntervalMedDivMed;                
                  
                  System.arraycopy(intervalArrayRawDiffMed, 1, intervalArrayRawDiffMed, 0, windowLength - 1);
                  intervalArrayRawDiffMed[windowLength - 1] = currentIntervalRawDiffMed;
                      
              }
              else if (n > windowLength) {
            	  
                  System.arraycopy(RRinRaw, 1, RRinRaw, 0, windowLength - 1);
                  RRinRaw[windowLength - 1] = rrinRaw;     

                  System.arraycopy(RRin, 1, RRin, 0, windowLength - 1);
                  RRin[windowLength - 1] = rrin;     
                  
                  System.arraycopy(intervalArrayRawDiff, 1, intervalArrayRawDiff, 0, windowLength - 1);
                  intervalArrayRawDiff[windowLength - 1] = currentIntervalRawDiff;
                  
                  System.arraycopy(intervalArrayRawDivMed, 1, intervalArrayRawDivMed, 0, windowLength - 1);
                  intervalArrayRawDivMed[windowLength - 1] = currentIntervalRawDivMed;

                  System.arraycopy(intervalArrayMedDivMed, 1, intervalArrayMedDivMed, 0, windowLength - 1);
                  intervalArrayMedDivMed[windowLength - 1] = currentIntervalMedDivMed;
            	  
                  System.arraycopy(intervalArrayRawDiffMed, 1, intervalArrayRawDiffMed, 0, windowLength - 1);
                  intervalArrayRawDiffMed[windowLength - 1] = currentIntervalRawDiffMed;             
              }
			  
              // Sinus arrhythmia suppression	                
              int cross; int tempCross = 0; int crossCounter = 0;
              for (int i = 0; i < intervalArrayRawDiff.length; i++) {

            	  if (intervalArrayRawDiff[i] > 0)            		  
            		  cross = 1;  
            	  else
            		  cross = 0;
            	  
            	  if (i > 0) {
            		  if ((cross - tempCross) != 0)
            			  crossCounter++;
            	  }           	  
            	  tempCross = cross;
              }
              
                            
              if (crossCounter < 2) 
            	  nDiff = 0;
              else 
            	  nDiff = func_count_matches(RRin, intervalArrayRawDiffMed, windowLength, r);
			  
              /*
              double rSum = 0; double rmSum = 0;
              for (int i = 0; i < RRin.length; i++) {
            	  rmSum += RRin[i]; 
            	  rSum += RRinRaw[i];	                     	
              }                        
              nRMS = Math.pow( ((rmSum / rSum) - 1), 2);
			  */
			  
              float rSum = 0; float rmSum = 0;
              for (int i = 0; i < intervalArrayMedDivMed.length; i++) {
                  rmSum += intervalArrayMedDivMed[i];
                  rSum += intervalArrayRawDivMed[i];
              }
              nRMS = Math.pow(((rmSum / rSum) - 1), 2);
              
              nDiffLP = mDigitalFilterExpIIR1.IIRFilter(nDiff, b, a);
              nMean = mDigitalFilterExpIIR2.IIRFilter(rrin, b, a);
              diffDivRms = mDigitalFilterExpIIR3.IIRFilter(nRMS, b, a);
              diffDivMean = nDiffLP / nMean;
                            
             /* 
             if (diffDivRms < 0.0002) {
                  diffDivMean = diffDivRms;
             }
             */
             
             if (diffDivRms < 0.0004f) {
                 diffDivMean = diffDivRms;
             }
             
             /*  
       	    if (diffDivMean > 0.725f) {
     	        detector1thr = 1;
     	        decision.add(detector1thr);
     	    }
     	    else  {
     	        detector1thr = 0;
     	        decision.add(detector1thr);
     	    }
     	    */
             
             if (diffDivMean > 0.635f) {
     	        detector1thr = 1;
     	        decision.add(detector1thr);
             }
             else {
     	        detector1thr = 0;
     	        decision.add(detector1thr);
             }
                                         
		  }
		  

		  double delay = 78;
		  
		  if (decision.size() >= (windowLength + delay - 1)) {
			  for (int i = 0; i < windowLength + delay - 1; i++ ) {
			  	decision.remove(i);
			  	decision.add(0.0);
		  	}		  	  
		  }

		  
		  //double[] paf_out = ListToDoubleArray(decision);  
		  //double[] paf_out2 = ListToDoubleArray(decision);
		  //double[] paf_out = new double[paf_out2.length];
		  

		  //int delay = (int) ((70 + windowLength) * 250);
		  //for (int i = delay; i < paf_out2.length; i++ ) {
		  //  paf_out[i - delay] = paf_out2[i];
		  //	}	
		  
		 
		  double[] AFibDetectorOut = ListToDoubleArray(decision);
		  
		  
		  
		  decision.clear();
  	    
		return AFibDetectorOut; 	
		//return paf_out; 
    }
	

    	
    double func_count_matches(double[] rrInt, double[] rrIntRawDiffMed, double windowLength, double r) {

        int differences = 0;

        for (int i = 0; i < windowLength; i++) {
            for (int j = i + 1; j < windowLength; j++) {
                if (Math.abs(rrIntRawDiffMed[i]) < 0.40 && Math.abs(rrIntRawDiffMed[i]) > 0.008) {
                    if (Math.abs(rrInt[i] - rrInt[j]) > r) {
                        differences++;
                    }
                }
            }}

        return differences / ( windowLength * ((windowLength - 1) / 2) );
    }
    
        

 
    /*
    double func_count_matches(double[] RRintervals, double windowLength, double r) {
		
		int differences = 0;
		
		for (int i = 0; i < windowLength; i++) {
			for (int j = i + 1; j < windowLength; j++) {
				
				if (Math.abs(RRintervals[i] - RRintervals[j]) > r ) {
					differences++;
				}
		}}
		
		double diffInd = differences / ( windowLength * ((windowLength - 1) / 2) );
		
		return diffInd ;	
	}
	*/
  
  
	double[] ListToDoubleArray(ArrayList<Double> arrayList) {
    	double[] DoubleArray = new double[arrayList.size()];
		for (int i = 0; i < arrayList.size(); i++) {
			
			DoubleArray[i] = (double) arrayList.get(i);
		}
		return DoubleArray;
    }
    
    
    
    
    
    
    
	
}