package ecg.afib.detector;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;

/**
*
* @author Andrius Solosenko
*/


public class AFibParametrizationForRDF {
	
	double AFbeats;
	double NonAFbeats;
	double AFibEpisodes;
	double AFibBurden;
	double AFibDensity;
	
	double AFibEpisodeStart;
	double AFibEpisodeDuration;
	int AvgAFibEpisodeHeartRate;
	
	double teoreticalAF;
	
	String AFibEpisodeStartDate;
	
	
	public ArrayList<AFibEpisode> AFibParameters(double Fd, double[] ECG, double[] AFibDetectorOut, int[] RRpeaks, double[] RRintervals, Date date) {
		
		
		long DateInMili = date.getTime();
		
		for (int i = 0; i < AFibDetectorOut.length; i++) {
			if (AFibDetectorOut[i] == 1)
				AFbeats++;            
			else
				NonAFbeats++;	
		}
			
		ArrayList<AFibEpisode> ECGAFibParameters = new ArrayList<AFibEpisode>();
		
		ArrayList<String> AFibEpisodeStartList = new ArrayList<String>();
		ArrayList<Double> AFibEpisodeDurationList = new ArrayList<Double>();
		ArrayList<Integer> AvgAFibEpisodHeartRateList = new ArrayList<Integer>();

		
		int AFibBeatCnt = 0; float cnt = 0.01f;
		for (int i = 0; i < AFibDetectorOut.length - 1; i++) {
			
			if (AFibDetectorOut[i] == 1) {
				AFibBeatCnt++;
				
				AFibEpisodeDuration = AFibEpisodeDuration + RRintervals[i];	
				
			     if ((1 / RRintervals[i] * 60) > 40 && (1 / RRintervals[i] * 60) < 280) {
			    	 cnt++; 	
			    	 AvgAFibEpisodeHeartRate =  (int) (AvgAFibEpisodeHeartRate + (1 / RRintervals[i] * 60));
			     }
			     			
				// Beginning of the AFib episode
				if (AFibBeatCnt == 1) {
					
					AFibEpisodeStart = RRpeaks[i];
					
				    SimpleDateFormat mSimpleDateFormat = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss'Z'");

				    long data = (long) (((AFibEpisodeStart / Fd) * 1000) + DateInMili);
				     
				    AFibEpisodeStartDate = mSimpleDateFormat.format(data);
				    
					AFibEpisodeStartList.add(AFibEpisodeStartDate);				       				   		
				}
				
				// End of the AFib episode
				if (AFibDetectorOut[i + 1] == 0 || i == (AFibDetectorOut.length - 2)) {					
	
	        		AFibEpisodeDurationList.add(AFibEpisodeDuration);
	        		AvgAFibEpisodHeartRateList.add( (int) (AvgAFibEpisodeHeartRate / cnt) );
	        			        		
	        		AFibBeatCnt = 0;
	        		cnt = 0.01f;
	        		AFibEpisodeDuration = 0;
	        		AvgAFibEpisodeHeartRate  = 0;
	        						
				}
										
			}
						
		}
							
		//System.out.println(AFibEpisodeStartList.size());
		//System.out.println(AFibEpisodeDurationList.size());
		//System.out.println(AvgAFibEpisodHeartRateList.size());
		
		for (int i = 0; i < AFibEpisodeStartList.size(); i++) {	
			AFibEpisode ep = new AFibEpisode(AFibEpisodeStartList.get(i), AFibEpisodeDurationList.get(i), AvgAFibEpisodHeartRateList.get(i));
			ECGAFibParameters.add(ep);		
		}
		
		
		
//		AFibBurden = (AFbeats / (AFbeats + NonAFbeats));
//		
//		if (AFibBurden == 1 || AFibBurden == 0) {
//			AFibDensity = 0;	
//		}	
//		else {
//			
//			double tempMax = 0; double realAF = 0;
//			double[] rrMax = new double[AFibDetectorOut.length];
//			double[] uni = new double[AFibDetectorOut.length];
//			
//			
//			for (int i = 0; i < AFibDetectorOut.length; i++) {			
//				for (int j = 0; j <= AFibDetectorOut.length - i; j++) {					
//					for (int k = j; k < j + i; k++) {
//	
//						if (AFibDetectorOut[k] == 1) {
//							AFibBeatCounter++;		
//						}																	
//					}
//					
//			        if (AFibBeatCounter > tempMax) {		        
//			        	tempMax = AFibBeatCounter;	
//			        }
//      			        
//			        AFibBeatCounter = 0;					
//				}
//								
//			    rrMax[i] = tempMax / AFbeats;
//			    uni[i] = (double) i / AFibDetectorOut.length;		  
//			    
//			    realAF = realAF + Math.abs(rrMax[i] - uni[i]);;		    			
//			}		
//								
//			teoreticalAF = ((1 - AFibBurden) / 2) * AFibDetectorOut.length;
//
//			AFibDensity = realAF / teoreticalAF;
//			
//		}			
//		
//		AFibParameters[0] = AFibEpisodes;
//		AFibParameters[1] = AFibBurden;
//		AFibParameters[2] = AFibDensity;
//		AFibParameters[3] = AFbeats;
//		AFibParameters[4] = NonAFbeats;	    		
		
		return ECGAFibParameters;
	}
	

}
