package ecg.afib.detector;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;

/**
*
* @author Andrius Solosenko
*/

public class AFibParametrizationForReport {
	
	double AFibEpisodeStart;
	double AFibEpisodeStop;
	double AFibEpisodeDuration;
	
	int AvgAFibEpisodeHeartRate;
		
	int AFibBeatCounter;
	double teoreticalAF;
	
	String AFibEpisodeStartDate;
	
	double[] AFibEpisodeArr;
		
	
	public ArrayList<AFibEpisodeECG> AFibParameters(double Fd, double[] ECG, double[] AFibDetectorOut, int[] RRpeaks, double[] RRintervals, Date date) {
		
		long DateInMili = date.getTime();
				
		
		ArrayList<AFibEpisodeECG> ecgAFibParameters = new ArrayList<AFibEpisodeECG>();
				
		ArrayList<String> AFibEpisodeStartList = new ArrayList<String>();
		ArrayList<Double> AFibEpisodeDurationList = new ArrayList<Double>();
		ArrayList<Integer> AvgAFibEpisodHeartRateList = new ArrayList<Integer>();
		ArrayList<double[]> AFibEpisodeArraysList = new ArrayList<double[]>();	
		
		int AFibBeatCnt = 0; float cnt = 0.01f;	
		for (int i = 0; i < AFibDetectorOut.length - 1; i++) {
				
			if (AFibDetectorOut[i] == 1) {
				AFibBeatCnt++;
				
				AFibEpisodeDuration = AFibEpisodeDuration + RRintervals[i];	
				
			     if ((1 / RRintervals[i] * 60) > 40 && (1 / RRintervals[i] * 60) < 280) {
			    	 cnt++; 	
			    	 AvgAFibEpisodeHeartRate =  (int) (AvgAFibEpisodeHeartRate + (1 / RRintervals[i] * 60));
			     }
				
				// Beginning of the AFib episode
				if (AFibBeatCnt == 1) {
					
					AFibEpisodeStart = RRpeaks[i];
					
				    SimpleDateFormat mSimpleDateFormat = new SimpleDateFormat("MM.dd HH:mm");

				    long data = (long) (((AFibEpisodeStart / Fd) * 1000) + DateInMili);
				     
				    AFibEpisodeStartDate = mSimpleDateFormat.format(data);
				       
				    AFibEpisodeStartList.add(AFibEpisodeStartDate);				
				}
				
				// End of the AFib episode
				if (AFibDetectorOut[i + 1] == 0 || i == (AFibDetectorOut.length - 2)) {					
	
					AFibEpisodeStop = RRpeaks[i];
					
					// Store AFib episode
					int n = 0; int difference = (int) (AFibEpisodeStop - AFibEpisodeStart);
					
					// Take ECG segments of not more than 5000 samples
					if (difference > 5000) {
						AFibEpisodeArr = new double[5000];
						AFibEpisodeStop = AFibEpisodeStart + 5000;
					}
					else
						AFibEpisodeArr = new double[difference];

						
					for (int k = (int) AFibEpisodeStart; k <  (int) AFibEpisodeStop; k++) {
						AFibEpisodeArr[n++] = ECG[k];
					}
					
					AFibEpisodeArraysList.add(AFibEpisodeArr);
	        		AFibEpisodeDurationList.add(AFibEpisodeDuration);
	        		AvgAFibEpisodHeartRateList.add( (int) (AvgAFibEpisodeHeartRate / cnt) );
	        		
	        		System.out.println("AFib episode start: " + AFibEpisodeStartDate);
	        		System.out.println("AFib episode duration: " + AFibEpisodeDuration);
	        		System.out.println("AFib HR: " + ((int) (AvgAFibEpisodeHeartRate / cnt)) );
	        			        		        			        			        		
	        		AFibBeatCnt = 0;
	        		cnt = 0.01f;
	        		AFibEpisodeDuration = 0;
	        		AvgAFibEpisodeHeartRate = 0;
	        						
				}		
							
			}
							
		}
		
		
		
			
		for (int i = 0; i < AFibEpisodeArraysList.size(); i++) {		
			AFibEpisodeECG ep = new AFibEpisodeECG(AFibEpisodeStartList.get(i), AFibEpisodeDurationList.get(i), AvgAFibEpisodHeartRateList.get(i), AFibEpisodeArraysList.get(i));
						
			ecgAFibParameters.add(ep);		
		}
		
		
		
		return ecgAFibParameters;
	}
	

}
