package ecg.afib.detector;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;

/**
*
* @author Andrius Solosenko
*/

public class SinusRhythmParametrizationForReport {
	
	int SinusRhythmAvgHeartRate;
	int SinusRhythmMaxHeartRate;
	int SinusRhythmMinHeartRate;
	
	double SinusRhythmStart;
	double SinusRhythmStop;
	
	double teoreticalAF;
	
	String SinusRhythmStartDate;
	
	double[] SinusRhythmArr;
	
	
	public ArrayList<SinusRhythmECG> SinusRhythmParameters(double Fd, double[] ECG, double[] AFibDetectorOut, int[] RRpeaks, double[] RRintervals, Date date) {
		
		
		long DateInMili = date.getTime();
						
		ArrayList<SinusRhythmECG> ecgSinusRhythmParameters = new ArrayList<SinusRhythmECG>();
		
		ArrayList<String> SinusRhythmStartList = new ArrayList<String>();
		ArrayList<Integer> SinusRhythmAvgHeartRateList = new ArrayList<Integer>();
		ArrayList<Integer> SinusRhythmMaxHeartRateList = new ArrayList<Integer>();
		ArrayList<Integer> SinusRhythmMinHeartRateList = new ArrayList<Integer>();
		ArrayList<double[]> SinusRhythmArraysList = new ArrayList<double[]>();
		ArrayList<String> EcgStartDateList = new ArrayList<String>();
		ArrayList<String> EcgStopDateList = new ArrayList<String>();
		ArrayList<String> EcgDurationList = new ArrayList<String>();
		ArrayList<double[]>  HrTrendList = new ArrayList<double[]>();
		
		SinusRhythmMaxHeartRate = (int) (1 / RRintervals[0] * 60);
		SinusRhythmMinHeartRate = (int) (1 / RRintervals[0] * 60);
		
		int SinusBeatCnt = 0; float cnt = 0.01f;		
		for (int i = 0; i < AFibDetectorOut.length - 1; i++) {
			
			 if (AFibDetectorOut[i] == 0) {
				     SinusBeatCnt++;
				     
				     if (i < RRintervals.length) {
					     if ((1 / RRintervals[i] * 60) > SinusRhythmMaxHeartRate && (1 / RRintervals[i] * 60) < 240) {			    	 
					    	 SinusRhythmMaxHeartRate = (int) (1 / RRintervals[i] * 60);
					    	 //System.out.println("Max HR: " + SinusRhythmMaxHeartRate);
					    	 SinusRhythmMinHeartRate = SinusRhythmMaxHeartRate;
					     }
					     					     
					     else if ((1 / RRintervals[i] * 60) < SinusRhythmMinHeartRate && (1 / RRintervals[i] * 60) > 20) {
					    	 SinusRhythmMinHeartRate = (int) (1 / RRintervals[i] * 60);
					    	 //System.out.println("Min HR: " + SinusRhythmMinHeartRate);
					     }
					     	     
					     if ((1 / RRintervals[i] * 60) > 20 && (1 / RRintervals[i] * 60) < 240) {
					    	 cnt++; 
					    	 SinusRhythmAvgHeartRate =  (int) (SinusRhythmAvgHeartRate + (1 / RRintervals[i] * 60));	    	 
					     }
				     }   	     
				     // Beginning of the sinus rhythm	
				     if (SinusBeatCnt == 1) {
				    	 	 
				    	    SinusRhythmStart = RRpeaks[i];
							
						    SimpleDateFormat mSimpleDateFormat = new SimpleDateFormat("MM.dd HH:mm");

						    long data = (long) (((SinusRhythmStart / Fd) * 1000) + DateInMili);
						     
						    SinusRhythmStartDate = mSimpleDateFormat.format(data);						 
						       
						    SinusRhythmStartList.add(SinusRhythmStartDate);
				     } 
				     
					// End of sinus rhythm
				    if (AFibDetectorOut[i + 1] == 1 || i == (AFibDetectorOut.length - 2)) {		
						
						SinusRhythmStop = RRpeaks[i];						
						
						// Store AFib episode
						int n = 0; int difference = (int) (SinusRhythmStop - SinusRhythmStart);
						
						// Take ECG segments of not more than 5000 samples
						if (difference > 5000) {
							SinusRhythmArr = new double[5000];
							SinusRhythmStop = SinusRhythmStart + 5000;
						}
						else
							SinusRhythmArr = new double[difference];

															
						for (int k = (int) SinusRhythmStart; k <  (int) SinusRhythmStop; k++) {
							SinusRhythmArr[n++] = ECG[k];
						}
						
						
						SinusRhythmArraysList.add(SinusRhythmArr);
						SinusRhythmAvgHeartRateList.add((int) (SinusRhythmAvgHeartRate / cnt));
						
						SinusRhythmMaxHeartRateList.add(SinusRhythmMaxHeartRate);
						SinusRhythmMinHeartRateList.add(SinusRhythmMinHeartRate);
						
						System.out.println("Sinus rhythm start: " + SinusRhythmStartDate);
						System.out.println("Sinus rhythm HR: " + ((int) (SinusRhythmAvgHeartRate / cnt)));
						
						SinusBeatCnt = 0;
						cnt = 0.01f;
						SinusRhythmAvgHeartRate = 0;	
						SinusRhythmMaxHeartRate = 0;
						SinusRhythmMinHeartRate = 0;		
					}
					
			}

		}
		
	    SimpleDateFormat sdfDate2 = new SimpleDateFormat("yyyy.MM.dd' 'HH:mm"); 
	    String ECGstartTime = sdfDate2.format(DateInMili);

	    long ECGstopDate = (long) (((ECG.length / Fd) * 1000) + DateInMili);
	     
	    String ECGstopTime = sdfDate2.format(ECGstopDate);
	       
	    SimpleDateFormat sdfDate3 = new SimpleDateFormat("HH:mm"); 
	    //String ECGduration = sdfDate3.format((long) ((ECG.length / Fd) * 1000));
	    String ECGduration = sdfDate3.format(ECGstopDate - DateInMili - 7200000);

		EcgStartDateList.add(ECGstartTime);
		EcgStopDateList.add(ECGstopTime); 
		EcgDurationList.add(ECGduration); 
		HrTrendList.add(RRintervals);
			
		for (int i = 0; i < SinusRhythmStartList.size(); i++) {			
			SinusRhythmECG sr = new SinusRhythmECG(SinusRhythmStartList.get(i), SinusRhythmAvgHeartRateList.get(i), SinusRhythmMaxHeartRateList.get(i), SinusRhythmMinHeartRateList.get(i), SinusRhythmArraysList.get(i), EcgStartDateList.get(0), EcgStopDateList.get(0), EcgDurationList.get(0), HrTrendList.get(0));
			ecgSinusRhythmParameters.add(sr);		
		}
		
		
		return ecgSinusRhythmParameters;
	}
	
	
	
}
