package ecg.dsp.tools;


public class DigitalAdaptiveFilter {

	double  a = 0.0001f;

    int i;

    double[] w;
    double[] x;
    double e;
    double y;
    double norm;

    boolean flag = true;

    public double NLMS(double mu, int M, double d, double ref) {

        if (flag) {
            w = new double[M];
            x = new double[M];
            flag = false;
        }

        y = w[0] * ref;

        for (i = 0; i < M - 1; i++) {
            y = y + w[i + 1] * x[i];
        }

        norm = 0;
        for (i = 0; i < M; i++) {
            norm = norm + (x[i] * x[i]);
        }
        norm = (float) Math.sqrt(norm);

        e = d - y;

        for (i = 0; i < M; i++) {
            //w[i] = w[i] + ( (mu * e * x[i]) / (norm + (1 / (e * e))) );
            w[i] = w[i] + ( (mu * e * x[i] ) / (norm + a) );
        }

        for (i = M - 1; i >= 1; --i) {
            x[i] = x[i - 1];
        }
        x[0] = ref;

        return e;
    }

}
