package ecg.dsp.tools;

/**
*
* @author Andrius Solosenko
*/

public class DigitalFilter {
   
    double[] xFIR;
    double outputFIR = 0;
    int LFIR = 0;
    boolean flagFIR = true;

    public double FIRFilter(double input, double[] bMA) {

        if (flagFIR) {
            xFIR = new double[bMA.length];
            LFIR = bMA.length - 1;
            flagFIR = false;
        }

        // calculate new output:
        outputFIR = input * bMA[0] ;
        for(int i = 0; i < LFIR; i++)
            outputFIR += xFIR[i] * bMA[i + 1];

        // update:
        for(int i = LFIR; i >= 1; i--)
            xFIR[i] = xFIR[i - 1];
        xFIR[0] = input;

        return outputFIR;
    }

    
    
	double[] xIIR;
    double[] yIIR;
    double outputIIR = 0;
    int LIIRb = 0;
    int LIIRa = 0;
    boolean flagIIR = true;

    public double IIRFilter(double input, double[] b, double[] a) {

        if (flagIIR) {
            xIIR = new double[b.length];
            yIIR = new double[a.length];
            LIIRb = b.length - 1;
            LIIRa = a.length - 1;
            flagIIR = false;
        }
    	
        // calculate new output:
        outputIIR = input * b[0] ;
        for(int i = 0; i < LIIRb; i++)
            outputIIR += xIIR[i] * b[i + 1];
        for(int i = 0; i < LIIRa; i++ )
            outputIIR -= yIIR[i] * a[i + 1];

        // update:
        for(int i = LIIRa; i >= 1; i--)
            yIIR[i] = yIIR[i - 1];
        yIIR[0] = outputIIR;

        for(int i = LIIRb; i >= 1; i--)
            xIIR[i] = xIIR[i - 1];
        xIIR[0] = input;

        return outputIIR;
    }
    
    
    
	
}
