/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package ecg.report;

import java.awt.Color;
import java.awt.Font;
import java.awt.geom.AffineTransform;

import org.apache.pdfbox.pdmodel.PDPage;
import org.apache.pdfbox.pdmodel.PDDocument;
import org.apache.pdfbox.pdmodel.edit.PDPageContentStream;
import org.apache.pdfbox.pdmodel.font.PDFont;
import org.apache.pdfbox.pdmodel.graphics.xobject.PDXObjectForm;

import java.io.*;

import org.apache.batik.dom.GenericDOMImplementation;
import org.apache.pdfbox.pdmodel.font.PDType1Font;
import org.jfree.chart.ChartFactory;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.axis.ValueAxis;
import org.jfree.chart.plot.CategoryPlot;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.chart.plot.ValueMarker;
import org.jfree.chart.plot.XYPlot;
import org.jfree.chart.renderer.category.BarRenderer;
import org.jfree.chart.renderer.category.StandardBarPainter;
import org.jfree.data.category.CategoryDataset;
import org.jfree.data.category.DefaultCategoryDataset;
import org.jfree.data.time.Second;
import org.jfree.data.time.TimeSeries;
import org.jfree.data.time.TimeSeriesCollection;
import org.jfree.data.xy.XYDataset;
import org.w3c.dom.DOMImplementation;
import org.w3c.dom.Document;

import java.awt.geom.Rectangle2D;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.Locale;

import org.apache.batik.transcoder.TranscoderInput;
import org.apache.batik.transcoder.TranscoderOutput;
import org.apache.batik.transcoder.Transcoder;
import org.apache.fop.svg.PDFTranscoder;
import org.apache.batik.svggen.SVGGraphics2D;
import org.apache.batik.transcoder.TranscoderException;
import org.apache.pdfbox.exceptions.COSVisitorException;
import org.apache.pdfbox.pdmodel.common.PDRectangle;
import org.apache.pdfbox.util.LayerUtility;
import org.w3c.dom.DOMException;

import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;

import ecg.afib.detector.AFibEpisodeECG;
import ecg.afib.detector.PatientInfo;
import ecg.afib.detector.SinusRhythmECG;
import finals.Finals;

/**
 *
 * @author Andrius Solosenko, Dainius Stankevicius
 */
public class PDFreport {

		
    private XYDataset createHRTrendDataset(Date startDate, double[] arr)
    {
      //final XYSeries hrTrendSeries = new XYSeries("HRtrend");       
      final TimeSeries hrTrendSeries = new TimeSeries("HRtrend");    
      
      Second current = new Second(startDate);
      
      	for (int i = 0; i < arr.length; i++) {
      		hrTrendSeries.add(current, (1 / arr[i] * 60));
      		current = (Second) current.next(); 
      	}
            
      //final XYSeriesCollection hrTrendDataset = new XYSeriesCollection(); 
      final TimeSeriesCollection hrTrendDataset = new TimeSeriesCollection();      
      hrTrendDataset.addSeries(hrTrendSeries); 
      
      return hrTrendDataset;
    }

    
    private XYDataset createECGSeriesDataset(Date startDate, double[] arr)
    {
 
      //final XYSeries ECGSeries = new XYSeries("ECG");     
      final TimeSeries ECGSeries = new TimeSeries("ECG");	
      
      Second current = new Second(startDate);
      
      	for (int i = 0; i < arr.length; i++) {
      		ECGSeries.add(current, arr[i]);	
      		current = (Second) current.next(); 
      	}
            
      //final XYSeriesCollection ecgDataset = new XYSeriesCollection(); 
      final TimeSeriesCollection ecgDataset = new TimeSeriesCollection();  
      ecgDataset.addSeries(ECGSeries);
      
      return ecgDataset;
    }
    
    
    private  CategoryDataset createAFibEpisodeDurationDataset(double[] arr)
    {
    	
      final DefaultCategoryDataset afEpisodesDataSet = new DefaultCategoryDataset();   
      
      int cnt1 = 0, cnt2 = 0, cnt3 = 0; 
      for (int i = 0; i < arr.length; i++) {
    	  if(arr[i] < 30 && arr[i] > 0 )
    		  cnt1++;
          else if (arr[i] < 360 && arr[i] > 0)
        	  cnt2++;
          else if (arr[i] > 1800)
        	  cnt3++;
      }
      
      afEpisodesDataSet.setValue(cnt1, "AFepisodes", "< 30 s");
      afEpisodesDataSet.setValue(cnt2, "AFepisodes", "< 6 min");
      afEpisodesDataSet.setValue(cnt3, "AFepisodes", "> 30 min");  

      return afEpisodesDataSet;
    }
    
    
    public static int random_int(int Min, int Max)
    {
         return (int) (Math.random()*(Max-Min))+Min;
    }

    

    public static Date convertStringToDate(String date) {
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy.MM.dd' 'HH:mm");
		Date dt = null;
			try {
				dt = sdf.parse(date);
				} catch (ParseException e) {
					e.printStackTrace();
				}
	 return dt; 
    }
    
    
    public static Date convertStringToDate2(String date) {
		SimpleDateFormat sdf = new SimpleDateFormat("MM.dd' 'HH:mm");
		Date dt = null;
			try {
				dt = sdf.parse(date);
				} catch (ParseException e) {
					e.printStackTrace();
				}
	 return dt; 
    }
    
    
   static String BMIstatus = "";
   public static String BMIstatus(String BMI) {
	
	if(BMI != null && !BMI.isEmpty()) {
	   if (Float.valueOf(BMI) <= 18.5f)
		   BMIstatus = "underweigth";
	   else if (Float.valueOf(BMI) > 18.5f && Float.valueOf(BMI) <= 25.0f)
		   BMIstatus = "normal";
	   else if (Float.valueOf(BMI) > 25.0f && Float.valueOf(BMI) <= 30.0f)
		   BMIstatus = "overweigth";
	   else if (Float.valueOf(BMI) > 30.0f)
		   BMIstatus = "obese";
	}

	return BMIstatus;   
   }
    
    
    
    /**
     * @param args the command line arguments
     */
    public boolean generatePDFreport(Object PatientInfoObj, ArrayList<AFibEpisodeECG> episodes, ArrayList<SinusRhythmECG> sinusrhythm)
    {    	
    	    	
    	DateFormat dateFormat = new SimpleDateFormat("MMMM dd, yyyy HH:mm", Locale.ENGLISH);
    	Calendar cal = Calendar.getInstance();
    	
        PDDocument document, hrTrendSource, afEpisodesSource, sinusECGSource, afibECG1Source, afibECG2Source;;
        Document hrTrendDocumentSvg, afEpisodesDocumentSvg, sinusECGDocumentSvg, afibECG1DocumentSvg, afibECG2DocumentSvg;
        
        JFreeChart hrTrend;
        JFreeChart afEpisodes;
        JFreeChart sinusECG;
        JFreeChart afibECG1;
        JFreeChart afibECG2;
        
        PDPageContentStream contentStream;
       
        
        	int randomSinusRhythm = random_int(0, sinusrhythm.size() - 1);
        	int randomAFibEpisode1 = 0;
        	int randomAFibEpisode2 = 0;
        	
        	
        	
        if (episodes.size() == 1) {
        	randomAFibEpisode1 = random_int(0, episodes.size() - 1);
        }
        else if (episodes.size() == 2) {
        	randomAFibEpisode1 = 0;
        	randomAFibEpisode2 = 1;
        }
        else if (episodes.size() > 2) {
        	randomAFibEpisode1 = random_int(0, episodes.size() - 1);
        	
    		while (true) { 	
    			randomAFibEpisode2 = random_int(0, episodes.size());   		
    			
    			if (randomAFibEpisode2 != randomAFibEpisode1 && randomAFibEpisode2 != 0) {	
    				break;
    			}
    			
    		}

        }
        
        
        double[] AFibEpisodeDurations = new double[episodes.size()];

        for (int i = 0; i < episodes.size(); i++) {
        	AFibEpisodeDurations[i] = episodes.get(i).getAFibDuration(); 
        }
        
		                              
        try
        {
            // Load .pdf template
            document = PDDocument.load(new File("filesReport/PatientReportTemplate.pdf"));
            // Get first page
            PDPage page = (PDPage) document.getDocumentCatalog().getAllPages().get(0);
            // Create new font for text
            PDFont font = PDType1Font.HELVETICA;
            // Start the content stream
            contentStream = new PDPageContentStream(document, page, true, true);
            // Set font for content stream
            contentStream.setFont(font, 12);
            
            
            // Add some text (Current date & time)
            contentStream.beginText();
            // At some custom position
            contentStream.setFont(PDType1Font.HELVETICA_BOLD, 12);
            contentStream.moveTextPositionByAmount(440, 820);
            contentStream.drawString(dateFormat.format(cal.getTime()));
            contentStream.endText();
         
            
            // Text writing begins
            // Add some text (Name)
            contentStream.beginText();
            // At some custom position
            contentStream.setFont(font, 12);
            contentStream.moveTextPositionByAmount(120, 766);
            contentStream.drawString(((PatientInfo) PatientInfoObj).getPatientName());
            contentStream.endText();
            // Add some more text (Surname)
            contentStream.beginText();
            // At another custom position
            contentStream.moveTextPositionByAmount(120, 745);
            contentStream.drawString(((PatientInfo) PatientInfoObj).getPatientSurname());
            contentStream.endText();
            // Add some text (Sex)
            contentStream.beginText();
            // At some custom position
            contentStream.moveTextPositionByAmount(120, 724);
            contentStream.drawString(((PatientInfo) PatientInfoObj).getPatientSex());
            contentStream.endText();
            // Add some text (Age)
            contentStream.beginText();
            // At some custom position
            contentStream.moveTextPositionByAmount(300, 766);
            contentStream.drawString(((PatientInfo) PatientInfoObj).getPatientAge());
            contentStream.endText();      
            // Add some text (Height)
            contentStream.beginText();
            // At some custom position
            contentStream.moveTextPositionByAmount(300, 745);
            contentStream.drawString(((PatientInfo) PatientInfoObj).getPatientHeight());
            contentStream.endText();  
            // Add some text (Weight)
            contentStream.beginText();
            // At some custom position
            contentStream.moveTextPositionByAmount(300, 724);
            contentStream.drawString(((PatientInfo) PatientInfoObj).getPatientWeight());
            contentStream.endText();  
   
            
            // Add some text (BMI)
            contentStream.beginText();
            // At some custom position
            contentStream.setFont(PDType1Font.HELVETICA_BOLD, 30);
            contentStream.moveTextPositionByAmount(445, 740);
            contentStream.drawString(((PatientInfo) PatientInfoObj).getPatientBMI());
            contentStream.endText();  
            
            // Add some text (BMI status)
            contentStream.beginText();
            // At some custom position
            contentStream.setFont(font, 12);
            contentStream.moveTextPositionByAmount(490, 721);
            contentStream.drawString(BMIstatus(((PatientInfo) PatientInfoObj).getPatientBMI()));
            contentStream.endText();  
            
            
            // Add some text (ECG start date)
            contentStream.beginText();
            // At some custom position
            contentStream.setFont(font, 12);
            contentStream.moveTextPositionByAmount(200, 676);
            if (sinusrhythm.size() != 0)
            contentStream.drawString(sinusrhythm.get(randomSinusRhythm).getEcgStartDate());
            contentStream.endText();  
            
            // Add some text (ECG stop date)
            contentStream.beginText();
            // At some custom position
            contentStream.setFont(font, 12);
            contentStream.moveTextPositionByAmount(345, 676);
            if (sinusrhythm.size() != 0)
            contentStream.drawString(sinusrhythm.get(randomSinusRhythm).getEcgStopDate());
            contentStream.endText();  
            
            // Add some text (ECG duration)
            contentStream.beginText();
            // At some custom position
            contentStream.setFont(font, 12);
            contentStream.moveTextPositionByAmount(510, 676);
            if (sinusrhythm.size() != 0)
            contentStream.drawString(sinusrhythm.get(randomSinusRhythm).getEcgDuration());
            contentStream.endText();  
            
            
            // Add some text (ECG min HR)
            contentStream.beginText();
            // At some custom position
            contentStream.setFont(font, 12);
            contentStream.moveTextPositionByAmount(120, 634);
            if (sinusrhythm.size() != 0)
            contentStream.drawString(Integer.toString(sinusrhythm.get(randomSinusRhythm).getSinusRhythmMinHeartRate()));
            contentStream.endText(); 
            
            // Add some text (ECG average HR)
            contentStream.beginText();
            // At some custom position
            contentStream.setFont(font, 12);
            contentStream.moveTextPositionByAmount(120, 612);
            if (sinusrhythm.size() != 0)
            contentStream.drawString(Integer.toString(sinusrhythm.get(randomSinusRhythm).getSinusRhythmAvgHeartRate()));
            contentStream.endText();  
            
            // Add some text (ECG max HR)
            contentStream.beginText();
            // At some custom position
            contentStream.setFont(font, 12);
            contentStream.moveTextPositionByAmount(120, 590);
            if (sinusrhythm.size() != 0)
            contentStream.drawString(Integer.toString(sinusrhythm.get(randomSinusRhythm).getSinusRhythmMaxHeartRate()));
            contentStream.endText();  
            
            // Add some text (ECG average HR in AF)
            contentStream.beginText();
            // At some custom position
            contentStream.setFont(font, 12);
            contentStream.moveTextPositionByAmount(138, 562);
            if (episodes.size() != 0)
            contentStream.drawString(Integer.toString(((episodes.get(randomAFibEpisode1).getAFibAvgHeartRate() + episodes.get(randomAFibEpisode2).getAFibAvgHeartRate()) / 2)));
            contentStream.endText();  
            
                      
            if (episodes.size() != 0) {
            // Add some text (ECG AFib status)
            contentStream.beginText();
            // At some custom position
            contentStream.setFont(PDType1Font.HELVETICA_BOLD, 14.2f);
            contentStream.moveTextPositionByAmount(252, 56);
            contentStream.drawString("Atrial fibrillation is suspected.");
            contentStream.endText();  
            
            contentStream.beginText();
            // At some custom position
            contentStream.setFont(PDType1Font.HELVETICA_BOLD, 14.2f);
            contentStream.moveTextPositionByAmount(180, 40);
            contentStream.drawString("Please print this report and show it to your physician.");
            contentStream.endText();  
            }
            else {
            contentStream.beginText();
            // At some custom position
            contentStream.setFont(PDType1Font.HELVETICA_BOLD, 14.2f);
            contentStream.moveTextPositionByAmount(248, 48);
            contentStream.drawString("No atrial fibrillation episodes found.");
            contentStream.endText();  	
            }
            
            
            
            // Add some text (Sinus rhythm start date)
            contentStream.beginText();
            // At some custom position
            contentStream.setFont(PDType1Font.HELVETICA_BOLD, 9.00f);
            contentStream.moveTextPositionByAmount(60, 502);
            if (sinusrhythm.size() != 0)
            contentStream.drawString(sinusrhythm.get(randomSinusRhythm).getSinusRhythmStartTime());
            contentStream.endText();  
            
            
            
            // Add some text (AFib episode start date)
            contentStream.beginText();
            // At some custom position
            contentStream.setFont(PDType1Font.HELVETICA_BOLD, 9.00f);
            contentStream.moveTextPositionByAmount(60, 349);
            if (episodes.size() != 0)
            contentStream.drawString(episodes.get(randomAFibEpisode1).getAFibStartTime());
            contentStream.endText();  
            
            
            // Add some text (AFib episode stop date)
            contentStream.beginText();
            // At some custom position
            contentStream.setFont(PDType1Font.HELVETICA_BOLD, 9.00f);
            contentStream.moveTextPositionByAmount(60, 196);
            if (episodes.size() != 0 && randomAFibEpisode2 != 0)
            contentStream.drawString(episodes.get(randomAFibEpisode2).getAFibStartTime());
            contentStream.endText();  
            
            
            // Text writing ends
            

            

            // Graph generation begins
            // Create a ECG trend chart      
            //hrTrend = ChartFactory.createXYLineChart("", "Hour", "HR, bpm", createHRTrendDataset(sinusrhythm.get(0).getHRtrend()), 
            //PlotOrientation.VERTICAL , false , true , false);
            if (sinusrhythm.size() != 0) {  
            	hrTrend = ChartFactory.createTimeSeriesChart("", "Hour", "HR, bpm", createHRTrendDataset(convertStringToDate(sinusrhythm.get(randomSinusRhythm).getEcgStartDate()), sinusrhythm.get(0).getHRtrend()), 
            false, true, false);
            }
            else {
            	hrTrend = ChartFactory.createTimeSeriesChart("", "Hour", "HR, bpm", createHRTrendDataset(convertStringToDate2("00.00 00:00"), new double[0]),
            			false, true, false);
            }
            // Get plot options
            XYPlot hrTrendPlot = hrTrend.getXYPlot();
            // Create new fonts for label and tick marks
            Font hrTrendLabelFont = new Font("Dialog", Font.PLAIN, 32); 
            Font hrTrendTickFont = new Font("Dialog", Font.PLAIN, 24);
            // Set these fonts
            hrTrendPlot.getDomainAxis().setLabelFont(hrTrendLabelFont);
            hrTrendPlot.getDomainAxis().setTickLabelFont(hrTrendTickFont);
            hrTrendPlot.getRangeAxis().setLabelFont(hrTrendLabelFont);
            hrTrendPlot.getRangeAxis().setTickLabelFont(hrTrendTickFont);
            // Set background color
            hrTrendPlot.setBackgroundPaint(Color.WHITE);
            // Set line color
            hrTrendPlot.getRenderer().setSeriesPaint(0, Color.black);
            // Remove chart border
            hrTrendPlot.setOutlineVisible(false);
            // Graph generation ends
            
            // SVG file generation begins
            // Don't know what this line does:
            DOMImplementation hrTrendDOM = GenericDOMImplementation.getDOMImplementation();
            // Create new .svg document
            hrTrendDocumentSvg = hrTrendDOM.createDocument(null, "svg", null);
            // Create SVG Generator
            SVGGraphics2D hrTrend_svg_generator = new SVGGraphics2D(hrTrendDocumentSvg);
            // Render chart as SVG 2D Graphics object
            hrTrend.draw(hrTrend_svg_generator, new Rectangle2D.Double(0, 0, 640, 240), null);
            hrTrend_svg_generator.stream("filesReport/hrTrendChart.svg"); 
            // SVG file generation ends

            // SVG to PDF convertion begins
            // Get URI to SVG file
            String hrTrendSvg_URI_input = Paths.get("filesReport/hrTrendChart.svg").toUri().toURL().toString();
            // Create Transcoder input
            TranscoderInput hrTrendInput_svg_image = new TranscoderInput(hrTrendSvg_URI_input);
            // Create outputstream for PDF file
            OutputStream hrTrendPdf_ostream = new FileOutputStream("filesReport/hrTrendChart.pdf");
            // Create transcoder output
            TranscoderOutput hrTrendOutput_pdf_file = new TranscoderOutput(hrTrendPdf_ostream); 
            // Create new transcoder
            Transcoder hrTrendTranscoder = new PDFTranscoder();
            // Add width and height parameters to the transcoder
            hrTrendTranscoder.addTranscodingHint(PDFTranscoder.KEY_WIDTH, new Float(640));
            hrTrendTranscoder.addTranscodingHint(PDFTranscoder.KEY_HEIGHT, new Float(240));
            // Write output to PDF format
            hrTrendTranscoder.transcode(hrTrendInput_svg_image, hrTrendOutput_pdf_file);
            // Flush and close output Stream  
            hrTrendPdf_ostream.flush();
            hrTrendPdf_ostream.close();
            // SVG to PDF convertion ends
            
            // PDF insertion into another PDF begins
            // Load the source file (our generated chart)
            hrTrendSource = PDDocument.load(new File("filesReport/hrTrendChart.pdf"));
            // Create new LayerUtility
            LayerUtility hrTrendLayer = new LayerUtility(document);
            // Import source PDF as an PDXObject
            PDXObjectForm hrTrendXobject = hrTrendLayer.importPageAsForm(hrTrendSource, 0);
            // Find the size of the target page
            PDRectangle hrTrendCropBox = page.findCropBox();
            // Create a transform for imported graph
            AffineTransform hrTrendTransform = new AffineTransform(0.4, 0, 0, 0.4, hrTrendCropBox.getWidth()*0.34, 0.675*hrTrendCropBox.getHeight());
            // Apply transform and draw imported chart
            contentStream.drawXObject(hrTrendXobject, hrTrendTransform);
            // Close the content stream
           
                       
           
            
            
           
            
            
            // Graph generation begins
            // Create a AFib episode chart
            afEpisodes = ChartFactory.createBarChart("", "Episode length", "Total", createAFibEpisodeDurationDataset(AFibEpisodeDurations),
            PlotOrientation.VERTICAL, false, true, false);
            // Get plot options
            CategoryPlot afEpisodesPlot = afEpisodes.getCategoryPlot();
            // Create new fonts for label and tick marks
            Font afEpisodesLabelFont = new Font("Dialog", Font.PLAIN, 32); 
            Font afEpisodesTickFont = new Font("Dialog", Font.PLAIN, 24);
            // Set these fonts
            afEpisodesPlot.getDomainAxis().setLabelFont(afEpisodesLabelFont);
            afEpisodesPlot.getDomainAxis().setTickLabelFont(afEpisodesTickFont);
            afEpisodesPlot.getRangeAxis().setLabelFont(afEpisodesLabelFont);
            afEpisodesPlot.getRangeAxis().setTickLabelFont(afEpisodesTickFont);
            // Set background color
            afEpisodesPlot.setBackgroundPaint(Color.WHITE);
            // Set line color
            afEpisodesPlot.getRenderer().setSeriesPaint(0, Color.black);
            // Set bar width
            BarRenderer br = (BarRenderer) afEpisodesPlot.getRenderer();
            br.setMaximumBarWidth(.10);
            // Set standard bar style
            br.setBarPainter(new StandardBarPainter());
            // Remove chart border
            afEpisodesPlot.setOutlineVisible(false);
            // Graph generation ends
            
            // SVG file generation begins
            // Don't know what this line does:
            DOMImplementation afEpisodesDOM = GenericDOMImplementation.getDOMImplementation();
            // Create new .svg document
            afEpisodesDocumentSvg = afEpisodesDOM.createDocument(null, "svg", null);
            // Create SVG Generator
            SVGGraphics2D afEpisodes_svg_generator = new SVGGraphics2D(afEpisodesDocumentSvg);
            // Render chart as SVG 2D Graphics object
            afEpisodes.draw(afEpisodes_svg_generator, new Rectangle2D.Double(0, 0, 500, 240), null);
            afEpisodes_svg_generator.stream("filesReport/afEpisodesChart.svg"); 
            // SVG file generation ends

            // SVG to PDF convertion begins
            // Get URI to SVG file
            String afEpisodesSvg_URI_input = Paths.get("filesReport/afEpisodesChart.svg").toUri().toURL().toString();
            // Create Transcoder input
            TranscoderInput afEpisodesInput_svg_image = new TranscoderInput(afEpisodesSvg_URI_input);
            // Create outputstream for PDF file
            OutputStream afEpisodesPdf_ostream = new FileOutputStream("filesReport/afEpisodesChart.pdf");
            // Create transcoder output
            TranscoderOutput afEpisodesOutput_pdf_file = new TranscoderOutput(afEpisodesPdf_ostream); 
            // Create new transcoder
            Transcoder afEpisodesTranscoder = new PDFTranscoder();
            // Add width and height parameters to the transcoder
            afEpisodesTranscoder.addTranscodingHint(PDFTranscoder.KEY_WIDTH, new Float(500));
            afEpisodesTranscoder.addTranscodingHint(PDFTranscoder.KEY_HEIGHT, new Float(240));
            // Write output to PDF format
            afEpisodesTranscoder.transcode(afEpisodesInput_svg_image, afEpisodesOutput_pdf_file);
            // Flush and close output Stream  
            afEpisodesPdf_ostream.flush();
            afEpisodesPdf_ostream.close();
            // SVG to PDF convertion ends
            
            // PDF insertion into another PDF begins
            // Load the source file (our generated chart)
            afEpisodesSource = PDDocument.load(new File("filesReport/afEpisodesChart.pdf"));
            // Create new LayerUtility
            LayerUtility afEpisodesLayer = new LayerUtility(document);
            // Import source PDF as an PDXObject
            PDXObjectForm afEpisodesXobject = afEpisodesLayer.importPageAsForm(afEpisodesSource, 0);
            // Find the size of the target page
            PDRectangle afEpisodesCropBox = page.findCropBox();
            // Create a transform for imported graph
            AffineTransform afEpisodesTransform = new AffineTransform(0.4, 0, 0, 0.4, afEpisodesCropBox.getWidth()*0.68, 0.675*afEpisodesCropBox.getHeight());
            // Apply transform and draw imported chart
            contentStream.drawXObject(afEpisodesXobject, afEpisodesTransform);
            // Close the content stream
            
            

            
            // Graph generation begins
            // Create a sinus ECG chart
            if (sinusrhythm.size() != 0) {  
            	//sinusECG = ChartFactory.createXYLineChart("", "Hour", "", createECGSeriesDataset(sinusrhythm.get(randomSinusRhythm).sinusRhythmArrays),
            	//		PlotOrientation.VERTICAL , false , true , false);
            	sinusECG = ChartFactory.createTimeSeriesChart("", "Hour", "",createECGSeriesDataset(convertStringToDate2(sinusrhythm.get(randomSinusRhythm).getSinusRhythmStartTime()), sinusrhythm.get(randomSinusRhythm).sinusRhythmArrays),
            	false, true, false);   
            }
            else {
            	//sinusECG = ChartFactory.createXYLineChart("", "Hour", "", createECGSeriesDataset(new double[5000]),
            	//		PlotOrientation.VERTICAL , false , true , false);
            	sinusECG = ChartFactory.createTimeSeriesChart("", "Hour", "", createECGSeriesDataset(convertStringToDate2("00.00 00:00"), new double[0]),
            	false , true , false);
            }
            // Get plot options
            XYPlot sinusECGplot = sinusECG.getXYPlot();
            
            //System.out.println(sinusrhythm.get(randomSinusRhythm).getSinusRhythmStartTime());         
            //ValueMarker marker = new ValueMarker(30000);  // position is the value on the axis
            //marker.setPaint(Color.red);
            //marker.setLabel("here"); // see JavaDoc for labels, colors, strokes
            //sinusECGplot.addDomainMarker(marker);
            
            // Create new fonts for label and tick marks
            Font sinusECGLabelFont = new Font("Dialog", Font.PLAIN, 32); 
            Font sinusECGTickFont = new Font("Dialog", Font.PLAIN, 24);
            // Set these fonts
            sinusECGplot.getDomainAxis().setLabelFont(sinusECGLabelFont);
            sinusECGplot.getDomainAxis().setTickLabelFont(sinusECGTickFont);
            sinusECGplot.getRangeAxis().setLabelFont(sinusECGLabelFont);
            sinusECGplot.getRangeAxis().setTickLabelFont(sinusECGTickFont);
            // Set background color
            sinusECGplot.setBackgroundPaint(Color.WHITE);
            // Set line color
            sinusECGplot.getRenderer().setSeriesPaint(0, Color.BLACK);
            // Remove chart border
            sinusECGplot.setOutlineVisible(false);
            // Add grid
            sinusECGplot.setDomainGridlinesVisible(true);
            sinusECGplot.setRangeGridlinesVisible(true);
            sinusECGplot.setRangeGridlinePaint(Color.black);
            sinusECGplot.setDomainGridlinePaint(Color.black);
            // Hide Y axis labels
            ValueAxis range = sinusECGplot.getRangeAxis();
            range.setVisible(false);
            // Graph generation ends
            
            // SVG file generation begins
            // Don't know what this line does:
            DOMImplementation sinusECGSVGDOM = GenericDOMImplementation.getDOMImplementation();
            // Create new .svg document
            sinusECGDocumentSvg = sinusECGSVGDOM.createDocument(null, "svg", null);
            // Create SVG Generator
            SVGGraphics2D sinusECG_svg_generator = new SVGGraphics2D(sinusECGDocumentSvg);
            // Render chart as SVG 2D Graphics object
            sinusECG.draw(sinusECG_svg_generator, new Rectangle2D.Double(0, 0, 1650, 350), null);
            sinusECG_svg_generator.stream("filesReport/sinusECGchart.svg"); 
            // SVG file generation ends

            // SVG to PDF convertion begins
            // Get URI to SVG file
            String sinusECGSvg_URI_input = Paths.get("filesReport/sinusECGChart.svg").toUri().toURL().toString();
            // Create Transcoder input
            TranscoderInput sinusECGInput_svg_image = new TranscoderInput(sinusECGSvg_URI_input);
            // Create outputstream for PDF file
            OutputStream sinusECGPdf_ostream = new FileOutputStream("filesReport/sinusECGChart.pdf");
            // Create transcoder output
            TranscoderOutput sinusECGOutput_pdf_file = new TranscoderOutput(sinusECGPdf_ostream); 
            // Create new transcoder
            Transcoder sinusECGTranscoder = new PDFTranscoder();
            // Add width and height parameters to the transcoder
            sinusECGTranscoder.addTranscodingHint(PDFTranscoder.KEY_WIDTH, new Float(1650));
            sinusECGTranscoder.addTranscodingHint(PDFTranscoder.KEY_HEIGHT, new Float(350));
            // Write output to PDF format
            sinusECGTranscoder.transcode(sinusECGInput_svg_image, sinusECGOutput_pdf_file);
            // Flush and close output Stream  
            sinusECGPdf_ostream.flush();
            sinusECGPdf_ostream.close();
            // SVG to PDF convertion ends
            
            // PDF insertion into another PDF begins
            // Load the source file (our generated chart)
            sinusECGSource = PDDocument.load(new File("filesReport/sinusECGChart.pdf"));
            // Create new LayerUtility
            LayerUtility sinusECGLayer = new LayerUtility(document);
            // Import source PDF as an PDXObject
            PDXObjectForm sinusECGXobject = sinusECGLayer.importPageAsForm(sinusECGSource, 0);
            // Find the size of the target page
            PDRectangle sinusECGCropBox = page.findCropBox();
            // Create a transform for imported graph
            AffineTransform sinusECGTransform = new AffineTransform(0.4, 0, 0, 0.4, sinusECGCropBox.getWidth()*0.09, 0.460*sinusECGCropBox.getHeight());
            // Apply transform and draw imported chart
            contentStream.drawXObject(sinusECGXobject, sinusECGTransform);
            
            
            
            
            // Graph generation begins
            // Create a AFib ECG1 chart
            if (episodes.size() != 0) {  
            	afibECG1 = ChartFactory.createTimeSeriesChart("", "Hour", "", createECGSeriesDataset(convertStringToDate2(episodes.get(randomAFibEpisode1).getAFibStartTime()), episodes.get(randomAFibEpisode1).AFibEpisodeArrays), 
            	false, true, false);     
            }
            else {
            	afibECG1 = ChartFactory.createTimeSeriesChart("", "Hour", "", createECGSeriesDataset(convertStringToDate2("00.00 00:00"), new double[0]), 
            	false, true, false);       	
            }
            // Get plot options
            XYPlot afibECG1plot = afibECG1.getXYPlot();
            // Create new fonts for label and tick marks
            Font afibECG1LabelFont = new Font("Dialog", Font.PLAIN, 32); 
            Font afibECG1TickFont = new Font("Dialog", Font.PLAIN, 24);
            // Set these fonts
            afibECG1plot.getDomainAxis().setLabelFont(afibECG1LabelFont);
            afibECG1plot.getDomainAxis().setTickLabelFont(afibECG1TickFont);
            afibECG1plot.getRangeAxis().setLabelFont(afibECG1LabelFont);
            afibECG1plot.getRangeAxis().setTickLabelFont(afibECG1TickFont);
            // Set background color
            afibECG1plot.setBackgroundPaint(Color.WHITE);
            // Set line color
            afibECG1plot.getRenderer().setSeriesPaint(0, Color.BLACK);
            // Remove chart border
            afibECG1plot.setOutlineVisible(false);
            // Add grid
            afibECG1plot.setDomainGridlinesVisible(true);
            afibECG1plot.setRangeGridlinesVisible(true);
            afibECG1plot.setRangeGridlinePaint(Color.black);
            afibECG1plot.setDomainGridlinePaint(Color.black);
            // Hide Y axis labels
            ValueAxis afibECG1range = afibECG1plot.getRangeAxis();
            afibECG1range.setVisible(false);
            // Graph generation ends
            
            // SVG file generation begins
            // Don't know what this line does:
            DOMImplementation afibECG1SVGDOM = GenericDOMImplementation.getDOMImplementation();
            // Create new .svg document
            afibECG1DocumentSvg = afibECG1SVGDOM.createDocument(null, "svg", null);
            // Create SVG Generator
            SVGGraphics2D afibECG1_svg_generator = new SVGGraphics2D(afibECG1DocumentSvg);
            // Render chart as SVG 2D Graphics object
            afibECG1.draw(afibECG1_svg_generator, new Rectangle2D.Double(0, 0, 1650, 350), null);
            afibECG1_svg_generator.stream("filesReport/afibECG1chart.svg"); 
            // SVG file generation ends

            // SVG to PDF convertion begins
            // Get URI to SVG file
            String afibECG1Svg_URI_input = Paths.get("filesReport/afibECG1Chart.svg").toUri().toURL().toString();
            // Create Transcoder input
            TranscoderInput afibECG1Input_svg_image = new TranscoderInput(afibECG1Svg_URI_input);
            // Create outputstream for PDF file
            OutputStream afibECG1Pdf_ostream = new FileOutputStream("filesReport/afibECG1Chart.pdf");
            // Create transcoder output
            TranscoderOutput afibECG1Output_pdf_file = new TranscoderOutput(afibECG1Pdf_ostream); 
            // Create new transcoder
            Transcoder afibECG1Transcoder = new PDFTranscoder();
            // Add width and height parameters to the transcoder
            afibECG1Transcoder.addTranscodingHint(PDFTranscoder.KEY_WIDTH, new Float(1650));
            afibECG1Transcoder.addTranscodingHint(PDFTranscoder.KEY_HEIGHT, new Float(350));
            // Write output to PDF format
            afibECG1Transcoder.transcode(afibECG1Input_svg_image, afibECG1Output_pdf_file);
            // Flush and close output Stream  
            afibECG1Pdf_ostream.flush();
            afibECG1Pdf_ostream.close();
            // SVG to PDF convertion ends
            
            // PDF insertion into another PDF begins
            // Load the source file (our generated chart)
            afibECG1Source = PDDocument.load(new File("filesReport/afibECG1Chart.pdf"));
            // Create new LayerUtility
            LayerUtility afibECG1Layer = new LayerUtility(document);
            // Import source PDF as an PDXObject
            PDXObjectForm afibECG1Xobject = afibECG1Layer.importPageAsForm(afibECG1Source, 0);
            // Find the size of the target page
            PDRectangle afibECG1CropBox = page.findCropBox();
            // Create a transform for imported graph
            AffineTransform afibECG1Transform = new AffineTransform(0.4, 0, 0, 0.4, afibECG1CropBox.getWidth()*0.09, 0.278*afibECG1CropBox.getHeight());
            // Apply transform and draw imported chart
            contentStream.drawXObject(afibECG1Xobject, afibECG1Transform);
            
            
            
            
            
            
            // Graph generation begins
            // Create a AFib ECG2 chart
            if (episodes.size() != 0 && randomAFibEpisode2 != 0) {   
                afibECG2 = ChartFactory.createTimeSeriesChart("", "Hour", "", createECGSeriesDataset(convertStringToDate2(episodes.get(randomAFibEpisode2).getAFibStartTime()), episodes.get(randomAFibEpisode2).AFibEpisodeArrays),
                false, true, false);
            }
            else {
            	afibECG2 = ChartFactory.createTimeSeriesChart("", "Hour", "", createECGSeriesDataset(convertStringToDate2("00.00 00:00"), new double[0]),
            	false, true, false);
            }
            // Get plot options
            XYPlot afibECG2plot = afibECG2.getXYPlot();
            // Create new fonts for label and tick marks
            Font afibECG2LabelFont = new Font("Dialog", Font.PLAIN, 32); 
            Font afibECG2TickFont = new Font("Dialog", Font.PLAIN, 24);
            // Set these fonts
            afibECG2plot.getDomainAxis().setLabelFont(afibECG2LabelFont);
            afibECG2plot.getDomainAxis().setTickLabelFont(afibECG2TickFont);
            afibECG2plot.getRangeAxis().setLabelFont(afibECG2LabelFont);
            afibECG2plot.getRangeAxis().setTickLabelFont(afibECG2TickFont);
            // Set background color
            afibECG2plot.setBackgroundPaint(Color.WHITE);
            // Set line color
            afibECG2plot.getRenderer().setSeriesPaint(0, Color.BLACK);
            // Remove chart border
            afibECG2plot.setOutlineVisible(false);
            // Add grid
            afibECG2plot.setDomainGridlinesVisible(true);
            afibECG2plot.setRangeGridlinesVisible(true);
            afibECG2plot.setRangeGridlinePaint(Color.black);
            afibECG2plot.setDomainGridlinePaint(Color.black);
            // Hide Y axis labels
            ValueAxis afibECG2range = afibECG2plot.getRangeAxis();
            afibECG2range.setVisible(false);
            // Graph generation ends
            
            // SVG file generation begins
            // Don't know what this line does:
            DOMImplementation afibECG2SVGDOM = GenericDOMImplementation.getDOMImplementation();
            // Create new .svg document
            afibECG2DocumentSvg = afibECG2SVGDOM.createDocument(null, "svg", null);
            // Create SVG Generator
            SVGGraphics2D afibECG2_svg_generator = new SVGGraphics2D(afibECG2DocumentSvg);
            // Render chart as SVG 2D Graphics object
            afibECG2.draw(afibECG2_svg_generator, new Rectangle2D.Double(0, 0, 1650, 350), null);
            afibECG2_svg_generator.stream("filesReport/afibECG2chart.svg"); 
            // SVG file generation ends

            // SVG to PDF convertion begins
            // Get URI to SVG file
            String afibECG2Svg_URI_input = Paths.get("filesReport/afibECG2Chart.svg").toUri().toURL().toString();
            // Create Transcoder input
            TranscoderInput afibECG2Input_svg_image = new TranscoderInput(afibECG2Svg_URI_input);
            // Create outputstream for PDF file
            OutputStream afibECG2Pdf_ostream = new FileOutputStream("filesReport/afibECG2Chart.pdf");
            // Create transcoder output
            TranscoderOutput afibECG2Output_pdf_file = new TranscoderOutput(afibECG2Pdf_ostream); 
            // Create new transcoder
            Transcoder afibECG2Transcoder = new PDFTranscoder();
            // Add width and height parameters to the transcoder
            afibECG2Transcoder.addTranscodingHint(PDFTranscoder.KEY_WIDTH, new Float(1650));
            afibECG2Transcoder.addTranscodingHint(PDFTranscoder.KEY_HEIGHT, new Float(350));
            // Write output to PDF format
            afibECG2Transcoder.transcode(afibECG2Input_svg_image, afibECG2Output_pdf_file);
            // Flush and close output Stream  
            afibECG2Pdf_ostream.flush();
            afibECG2Pdf_ostream.close();
            // SVG to PDF convertion ends
            
            // PDF insertion into another PDF begins
            // Load the source file (our generated chart)
            afibECG2Source = PDDocument.load(new File("filesReport/afibECG2Chart.pdf"));
            // Create new LayerUtility
            LayerUtility afibECG2Layer = new LayerUtility(document);
            // Import source PDF as an PDXObject
            PDXObjectForm afibECG2Xobject = afibECG2Layer.importPageAsForm(afibECG2Source, 0);
            // Find the size of the target page
            PDRectangle afibECG2CropBox = page.findCropBox();
            // Create a transform for imported graph
            AffineTransform afibECG2Transform = new AffineTransform(0.4, 0, 0, 0.4, afibECG2CropBox.getWidth()*0.09, 0.095*afibECG2CropBox.getHeight());
            // Apply transform and draw imported chart
            contentStream.drawXObject(afibECG2Xobject, afibECG2Transform);
            
            
            
            // Close the content stream
            contentStream.close();
            // PDF insertion into another PDF ends
                                    
            hrTrendSource.close();
            afEpisodesSource.close();
            sinusECGSource.close();
            afibECG1Source.close();
            afibECG2Source.close();
            
            
            // Close all open files and save report
            document.save(Finals.homeDir + "PatientReport.pdf");
            document.close();
            
            System.out.println("ECG REPORT IS READY");

        } catch (IOException | DOMException | TranscoderException | COSVisitorException io)
        {
            System.out.println(io);
        }
        
		return true;
		
    }
}


