/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package lemur.dataStructures;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.PrintStream;
import java.io.Serializable;
import java.io.UnsupportedEncodingException;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author drosatosgr
 */
public class ListOfDocumentsInIndex implements Serializable {

    private static final long serialVersionUID = -5945834518511397133L;
    public Hashtable<Integer, DocumentOfIndex> docs;

    public ListOfDocumentsInIndex() {
        docs = new Hashtable<Integer, DocumentOfIndex>();
    }

    public void loadSavedObject() {
        loadSavedObject(this.getClass().getSimpleName() + ".data");
    }
    
    public void loadSavedObject(String file) {
        FileInputStream fis = null;
        ObjectInputStream in = null;
        try {

            fis = new FileInputStream(file);
            in = new ObjectInputStream(fis);
            ListOfDocumentsInIndex liofac = (ListOfDocumentsInIndex) in.readObject();
            this.docs = liofac.docs;
            in.close();
        } catch (IOException ex) {
            ex.printStackTrace();
        } catch (ClassNotFoundException ex) {
            ex.printStackTrace();
        }
    }

    public void saveObject() {
        FileOutputStream fos = null;
        ObjectOutputStream out = null;
        try {
            fos = new FileOutputStream(this.getClass().getSimpleName() + ".data");
            out = new ObjectOutputStream(fos);
            out.writeObject(this);
            out.close();
        } catch (IOException ex) {
            ex.printStackTrace();
        }
    }
    
    public void saveToTrecFormat(String file){
        PrintStream writer = null;
        try {
            Enumeration<Integer> en = docs.keys();
            writer = new PrintStream(new File(file),"UTF-8");
            while (en.hasMoreElements()) {
                int docid = en.nextElement();
                writer.println(docs.get(docid).toTrecText());
            }   
            writer.close();
        } catch (FileNotFoundException ex) {
            Logger.getLogger(ListOfDocumentsInIndex.class.getName()).log(Level.SEVERE, null, ex);
        } catch (UnsupportedEncodingException ex) {
            Logger.getLogger(ListOfDocumentsInIndex.class.getName()).log(Level.SEVERE, null, ex);
        } finally {
            writer.close();
        }
    }

}
