/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package lemur;

import com.google.gson.JsonArray;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParser;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.Hashtable;
import java.util.List;
import java.util.Map;
import java.util.logging.Level;
import java.util.logging.Logger;
import sqlite.dataSources.Category;
import lemur.dataStructures.CategoryScoreRank;
import lemurproject.indri.ParsedDocument;
import lemurproject.indri.QueryEnvironment;
import lemurproject.indri.ScoredExtentResult;
import org.supercsv.cellprocessor.Optional;
import org.supercsv.cellprocessor.ParseInt;
import org.supercsv.cellprocessor.constraint.NotNull;
import org.supercsv.cellprocessor.ift.CellProcessor;
import org.supercsv.io.CsvListReader;
import org.supercsv.io.ICsvListReader;
import org.supercsv.prefs.CsvPreference;
import sqlite.CategoryDataSource;

/**
 *
 * @author drosatosgr
 */
public class queryIndexTesting {

    public static void main(String[] args) {
        System.setProperty("java.library.path", ".");
        
        String testindex = "files/kddcup05_v2/";
        //String testindex = "files/similarweb_v2/";
        //String testindex = "files/kddcup05_v1/";
        String csv = "files/KDD_Categories_v2.csv";
        int Threshold = 100000;
        String query = "zoo disny";
        try {
            QueryEnvironment qenv = new QueryEnvironment();
            qenv.addIndex(testindex);
            //System.out.println(qenv.documentCount());
            //String newquery = qenv.reformulateQuery(query.replaceAll("[^a-z\\sA-Z0-9]", " ").trim().toLowerCase());
            
            ScoredExtentResult[] scResult = qenv.runQuery(query.replaceAll("[^a-z\\sA-Z0-9]", " ").trim().toLowerCase(), Threshold); //want: document = idDocumentClueWebIndex, score = LM score, order = rank of results
            //String[] docno = qenv.documentMetadata(scResult, "docno");
            String[] doccateg = qenv.documentMetadata(scResult, "docat");
            //ParsedDocument[] pd = qenv.documents(scResult); //want: text = stems sequence of words
                 
            Hashtable<Integer, Category> categs = loadCategoriesFromCSV(csv);
            
            Hashtable<Integer, Double> count = new Hashtable<Integer, Double>();
            Hashtable<Integer, Double> count2 = new Hashtable<Integer, Double>();
            //Double sumScore = 0.0;
            for (int r = 0; r < scResult.length; r++) {
                //System.out.println(" - "+(r+1)+"\t"+scResult[r].score);
                JsonArray ja = (JsonArray) new JsonParser().parse(doccateg[r]);
                //System.out.println(" ---------------------------- ");
                for(int j=0;j<ja.size();j++){
                    CategoryScoreRank csr = new CategoryScoreRank(ja.get(j).getAsJsonObject());
                    //System.out.println(csr.toJSONString());
                    //System.out.println(csr._id+"\t"+csr.name+"\t"+csr.parent_id+"\t"+csr.rank);
                    if(!count.containsKey(csr._id)){
                        count.put(csr._id, Math.pow(2.0, scResult[r].score));
                    }else{
                        count.replace(csr._id,count.get(csr._id)+Math.pow(2.0, scResult[r].score));
                    }

                    if(!count2.containsKey(csr.parent_id)){
                        count2.put(csr.parent_id, Math.pow(2.0, scResult[r].score));
                    }else{
                        count2.replace(csr.parent_id,count2.get(csr.parent_id)+Math.pow(2.0, scResult[r].score));
                    }
                    //sumScore += Math.pow(2.0, scResult[r].score)*Math.pow(2.0, csr.score);
                }
                //System.out.println(" ---------------------------- ");
                //System.out.println(sumScore+"\t"+(r+1)+"\t"+sumScore/(r+1));
                //if(sumScore > 0.8) break;
            }

            //System.out.println("- "+sumScore+"\t"+scResult.length+"\t"+sumScore/scResult.length);
            
                   //Transfer as List and sort it
       ArrayList<Map.Entry<Integer, Double>> l = new ArrayList(count.entrySet());
       Collections.sort(l, new Comparator<Map.Entry<Integer, Double>>(){
         public int compare(Map.Entry<Integer, Double> o1, Map.Entry<Integer, Double> o2) {
            return o1.getValue().compareTo(o2.getValue());
        }});

       for(int q=0;q<l.size();q++){
           System.out.println(categs.get(l.get(q).getKey())._id + " "+ categs.get(l.get(q).getKey()).name +" -> "+l.get(q).getValue());
       }
       System.out.println("-----------------------------------");
                          //Transfer as List and sort it
       ArrayList<Map.Entry<Integer, Double>> ll = new ArrayList(count2.entrySet());
       Collections.sort(ll, new Comparator<Map.Entry<Integer, Double>>(){
         public int compare(Map.Entry<Integer, Double> o1, Map.Entry<Integer, Double> o2) {
            return o1.getValue().compareTo(o2.getValue());
        }});

       for(int q=0;q<ll.size();q++){
           System.out.println(categs.get(ll.get(q).getKey())._id + " "+ categs.get(ll.get(q).getKey()).name +" -> "+ll.get(q).getValue());
       }
       
            qenv.close();
        } catch (Exception e) {
            System.err.println("ERROR to open index '" + testindex + "' in retrieveSuggestionsForSpecificTopics(...)':" + e.toString());
        }
        
    }

//    public static String[] getDocumentsIDs(QueryEnvironment qenv, String squery, int threshold) {
//
//        //ArrayList<Integer> results = new ArrayList<Integer>();
//        String[] docno = null;
//        try {
//            //////////////////////////////////////////////////////////
//
//	    // Run query
//            //String orquery = "#or(" + squery + ")";
//            String orquery = squery;
//            ScoredExtentResult[] or_results = qenv.runQuery(orquery, threshold);
//
//            //////////////////////////////////////////////////////////////
//            docno = qenv.documentMetadata(or_results, "docno");
//
//	    /////////////////////////////////////////////////////////////
//            //
//            //for (int i = 0; i < or_results.length; i++){
//            //	results.add(or_results[i].document);
//            //}
//        } catch (Exception e) {
//            System.err.println("ERROR With getting Documents IDs 'getDocumentsIDs(...)':" + e.toString());
//        }
//
//        //return results;
//        return docno;
//    }

    public static Hashtable<Integer, Category> loadCategoriesFromCSV(String file) {
        Hashtable<Integer, Category> categ = new Hashtable<Integer, Category>();
        try {
            //CsvPreference SPACE_DELIMITED = new CsvPreference.Builder('"', ' ', "\r\n").build();
            CsvPreference STANDARD_PREFERENCE = new CsvPreference.Builder('"', ';', "\r\n").build();
            ICsvListReader inFile = new CsvListReader(new FileReader(file), STANDARD_PREFERENCE /*CsvPreference.STANDARD_PREFERENCE*/);
            final CellProcessor[] processors = new CellProcessor[]{
                new NotNull(new ParseInt()), //_id
                new NotNull(), // name
                new Optional(), // description
                new Optional(new ParseInt()), //parent_id
                new Optional(new ParseInt()), //forUploading
            };

            String[] header = inFile.getHeader(true);
            List<Object> customerList;
            while ((customerList = inFile.read(processors)) != null) {

                Integer _id = (Integer) customerList.get(0);
                String name = (String) customerList.get(1);
                String desc = (String) customerList.get(2);
                Integer parent_id = (Integer) customerList.get(3);
                Integer forUploading = (Integer) customerList.get(4);

                //if (parent_id != null) {
                    categ.put(_id, new Category(_id, name, desc, parent_id, forUploading));
                //}
            }

            inFile.close();

        } catch (FileNotFoundException ex) {
            Logger.getLogger(CategoryDataSource.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IOException ex) {
            Logger.getLogger(CategoryDataSource.class.getName()).log(Level.SEVERE, null, ex);
        }
        return categ;
    }

    
}
