package mainPackage;
/*
 * TrayIconCarre.java
 */

import java.awt.AWTException;
import java.awt.CheckboxMenuItem;
import java.awt.Desktop;
import java.awt.MenuItem;
import java.awt.PopupMenu;
import java.awt.SystemTray;
import java.awt.TrayIcon;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.nio.file.attribute.FileAttribute;
import java.security.KeyStore;
import java.security.cert.Certificate;
import java.security.cert.CertificateFactory;
import java.security.cert.X509Certificate;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.UUID;
import java.util.concurrent.Executors;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.TimeUnit;
import java.util.logging.FileHandler;
import java.util.logging.Level;
import java.util.logging.Logger;

import javax.net.ssl.SSLContext;
import javax.net.ssl.TrustManagerFactory;
import javax.swing.JFileChooser;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;
import javax.swing.filechooser.FileFilter;

import org.apache.jena.atlas.web.HttpException;
import org.apache.jena.atlas.web.auth.HttpAuthenticator;
import org.apache.jena.atlas.web.auth.SimpleAuthenticator;
import org.tmatesoft.sqljet.browser.DBBrowser;

import com.hp.hpl.jena.query.Query;
import com.hp.hpl.jena.query.QueryExecution;
import com.hp.hpl.jena.query.QueryExecutionFactory;
import com.hp.hpl.jena.query.QueryFactory;
import com.hp.hpl.jena.query.QueryParseException;
import com.hp.hpl.jena.query.ResultSet;
import com.hp.hpl.jena.update.UpdateExecutionFactory;
import com.hp.hpl.jena.update.UpdateFactory;
import com.hp.hpl.jena.update.UpdateProcessor;
import com.hp.hpl.jena.update.UpdateRequest;
import com.jmatio.io.MatFileReader;

import dialogs.AboutJFrame;
import dialogs.FileUploadJFrame;
import dialogs.GraphJFrame;
import dialogs.PatientInfoJFrame;
import dialogs.SetUserJFrame;
import dialogs.StatisticsJFrame;
import ecg.afib.detector.AFibDetector;
import ecg.afib.detector.AFibEpisode;
import ecg.afib.detector.AFibParametrizationForRDF;
import ecg.afib.detector.AFibParametrizationForReport;
import ecg.afib.detector.PatientInfo;
import ecg.afib.detector.SinusRhythmParametrizationForReport;
import ecg.dsp.tools.DigitalFilter;
import ecg.dsp.tools.FilterCoefficients;
import ecg.dsp.tools.MovingAverageFilter;
import ecg.edf.tools.EDFParser;
import ecg.edf.tools.EDFParserException;
import ecg.edf.tools.EDFParserResult;
import ecg.report.PDFreport;
import finals.Finals;
//import static finals.Finals.checkingPeriodOfRDFSender;
import scheduler.CategorizerExecutionRunnable;
import scheduler.RDFSenderExecutionRunnable;
import sqlite.MySQLiteHelper;
import tools.RefineryUtilities;
import usb.drive.checker.DriveChecker;
import virtuoso.AES;
import webserver.WServer;
import weka.gui.ExtensionFileFilter;

public class TrayIconCarre {

    static MySQLiteHelper db;
    
    static ScheduledExecutorService scheduler = null;
    
    static WServer wServer;
    
    static DBBrowser br = null;
    static AboutJFrame ab = null;
    static PatientInfoJFrame pb = null;
    public static SetUserJFrame su = null;
    static GraphJFrame gb = null;
    static StatisticsJFrame st = null;
    static FileUploadJFrame fu = null;
    
    static MenuItem ecgReportItem;
    static MenuItem ecgFileItem;
    
    static MenuItem ecgFileUploadItem;
    
    MatFileReader mMatFileReader = null;
	static AFibDetector mAFibDetector = null; 
	static AFibParametrizationForRDF mAFibParametrizationForRDF  = null;
	static AFibParametrizationForReport mAFibParametrizationForReport  = null;
	static SinusRhythmParametrizationForReport mSinusRhythmParametrizationForReport  = null;
	
	static PDFreport mPDFreport = null;
		
	static DigitalFilter mDigitalFilterECGhighPrep  = null;
	static DigitalFilter mDigitalFilterECGlowPrep   = null;
	static DigitalFilter mDigitalFilterECGnotchPrep = null;
		
	static DigitalFilter mDigitalFilterECGhighProc  = null;
	static DigitalFilter mDigitalFilterECGlowProc   = null;
	static DigitalFilter mDigitalFilterECGintegProc = null;
	
	static FilterCoefficients mFilterCoefficients = null;

	static MovingAverageFilter smooth = null;
	
	//static double Fs = 500;	
	static double Fs = 250;
	
	double AFbeats;
	double NonAFbeats;
	
	double AFibBurden;
	double AFibDensity;
    
	// BEGIN ------- ADDME
    static {
        try {
            KeyStore keyStore = KeyStore.getInstance(KeyStore.getDefaultType());
            Path ksPath = Paths.get(System.getProperty("java.home"),"lib", "security", "cacerts");
            keyStore.load(Files.newInputStream(ksPath),"changeit".toCharArray());

            CertificateFactory cf = CertificateFactory.getInstance("X.509");
            InputStream caInput = new BufferedInputStream(TrayIconCarre.class.getResourceAsStream("DSTRootCAX3.der"));
            InputStream caInput2 = new BufferedInputStream(TrayIconCarre.class.getResourceAsStream("StartComCertificationAuthority.der"));
            Certificate crt = cf.generateCertificate(caInput);
            Certificate crt2 = cf.generateCertificate(caInput2);
            System.out.println("Added Cert for " + ((X509Certificate) crt).getSubjectDN());
            System.out.println("Added Cert for " + ((X509Certificate) crt2).getSubjectDN());
            keyStore.setCertificateEntry("DSTRootCAX3", crt);     
            keyStore.setCertificateEntry("StartComCertificationAuthority", crt2);   

//            if (false) { // enable to see
//                System.out.println("Truststore now trusting: ");
//                PKIXParameters params = new PKIXParameters(keyStore);
//                params.getTrustAnchors().stream();
//                        .map(TrustAnchor::getTrustedCert)
//                        .map(X509Certificate::getSubjectDN)
//                        .forEach(System.out::println);
//                System.out.println();
//            }

            TrustManagerFactory tmf = TrustManagerFactory.getInstance(TrustManagerFactory.getDefaultAlgorithm());
            tmf.init(keyStore);
            SSLContext sslContext = SSLContext.getInstance("TLS");
            sslContext.init(null, tmf.getTrustManagers(), null);
            SSLContext.setDefault(sslContext);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
    }
    // END ---------- ADDME
    
    public static void main(String[] args) {
        try {
            Files.createDirectory(Paths.get(Finals.logsFolder));
            Logger.getLogger("").addHandler(new FileHandler(Finals.logs, 1 * 1024 * 1024, 3, true));
        } catch (IOException ex) {
            Logger.getLogger(TrayIconCarre.class.getName()).log(Level.SEVERE, null, ex);
        } catch (SecurityException ex) {
            Logger.getLogger(TrayIconCarre.class.getName()).log(Level.SEVERE, null, ex);
        }
        
        db = MySQLiteHelper.getInstance();
        
        Finals.loadProperties();
        
        //Check to start with windows or not
        if(args.length == 1 && args[0].equals("autostart")){
            if(!Finals.stWithWindows) return;
        }       
        
        wServer = new WServer(db);
        
        scheduler = Executors.newScheduledThreadPool(Finals.threadsOnScheduler);
        
        scheduler.execute(wServer);
        scheduler.scheduleAtFixedRate(new CategorizerExecutionRunnable(db,Finals.indexForCategorizer), Finals.checkingPeriodOfCategorizer, Finals.checkingPeriodOfCategorizer, TimeUnit.SECONDS);
        scheduler.scheduleAtFixedRate(new RDFSenderExecutionRunnable(db), Finals.checkingPeriodOfCategorizer+(Finals.checkingPeriodOfRDFSender/2), Finals.checkingPeriodOfRDFSender, TimeUnit.SECONDS);
        //scheduler.scheduleAtFixedRate(XXUploader, XXXX, XXXX, TimeUnit.SECONDS); //TODO

        /* Use an appropriate Look and Feel */
        try {
            UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
            //UIManager.setLookAndFeel("javax.swing.plaf.metal.MetalLookAndFeel");
        } catch (UnsupportedLookAndFeelException ex) {
            ex.printStackTrace();
        } catch (IllegalAccessException ex) {
            ex.printStackTrace();
        } catch (InstantiationException ex) {
            ex.printStackTrace();
        } catch (ClassNotFoundException ex) {
            ex.printStackTrace();
        }
        /* Turn off metal's use of bold fonts */
        UIManager.put("swing.boldMetal", Boolean.FALSE);
        //Schedule a job for the event-dispatching thread:
        //adding TrayIcon.
        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                createAndShowGUI();
            }
        });
        
                
        // USB input detection
    	while (!Thread.currentThread().isInterrupted()) {
    	    try {   	    
    	    	
    	    	DriveChecker.updateDriveInfo();
    	    	
    	    	Thread.sleep(2000);     	 
    	    	   	    		
    	    	if (DriveChecker.newDriveDetected()) {
    	    		System.out.println("USB device inserted");
    	    		
    				JFileChooser chooser = new JFileChooser();
    				
    				FileFilter mFileFilter = new ExtensionFileFilter(new String[] { "edf" }, "edf");
    			    chooser.setFileFilter(mFileFilter);
    			    
    			    //File dir = new File(DriveChecker.getDriveDir());
    			    File dir = new File(DriveChecker.getDriveDir() + "DATA");
    			    dir.mkdir();
    			         			    
    			    chooser.setCurrentDirectory(dir);   			    

    				int choice = chooser.showOpenDialog(chooser);    	

    			    switch (choice) {
    			    case JFileChooser.APPROVE_OPTION:
    			      System.out.println("Approve (Open or Save) was clicked");
    			            
    				File chosenFile = chooser.getSelectedFile();
    				
    		        if (chosenFile == null) {
    		            return;     	
    		        }
    		        else {
                        // Disable menu items
    		        	ecgFileItem.setEnabled(false);
                        ecgReportItem.setEnabled(false);
    		        }
    		        	
    		        String edfFilePath = chooser.getSelectedFile().getAbsolutePath();
    				
    		        AFibDetector(edfFilePath);
    				
    		        ecgFileItem.setEnabled(true);
    		        ecgReportItem.setEnabled(true);
    			      
    			      break;
    			    case JFileChooser.CANCEL_OPTION:
    			      System.out.println("Cancel or the close-dialog icon was clicked");
    			      break;
    			    case JFileChooser.ERROR_OPTION:
    			      System.out.println("Error");
    			      break;
    			    }	
    			    

    			}
	
    	    	else if (DriveChecker.driveRemoved()) {
    	    		System.out.println("USB device removed");
    	        }
    	    	

    	    } catch (InterruptedException ex) {
    	    	System.out.println("Interrputed THREAD");
    	        Thread.currentThread().interrupt();
    	    }
    	}
       
    	
    }
    
    


    
    
    private static void createAndShowGUI() {
        //Check the SystemTray support
        if (!SystemTray.isSupported()) {
            System.out.println("SystemTray is not supported");
            return;
        }
        final PopupMenu popup = new PopupMenu();
        Finals.trayIcon = new TrayIcon(Finals.putIconImage(), Finals.appName+" ("+Finals.appSubName+") "+Finals.appVersion);
        Finals.trayIcon.setImageAutoSize(true);
        Finals.trayIcon.setToolTip(Finals.appName+"\n("+Finals.appSubName+")");
        final SystemTray tray = SystemTray.getSystemTray();

        // Create a popup menu components
        MenuItem aboutItem = new MenuItem("About");
        MenuItem patientInfoItem = new MenuItem("Patient Info");
        aboutItem.setFont(new java.awt.Font("Tahoma", 1, 11));
        MenuItem accountItem = new MenuItem("Set Account");
        ecgFileItem = new MenuItem("Load ECG file");
        ecgReportItem = new MenuItem("ECG analysis report");
        ecgFileUploadItem = new MenuItem("Upload ECG file");
        MenuItem browseDBItem = new MenuItem("Browse DB");
        MenuItem visualItem = new MenuItem("Visualization of Results");
        MenuItem statsItem = new MenuItem("Statistics");
        CheckboxMenuItem cb1 = new CheckboxMenuItem("Start with Windows");
        if(Finals.stWithWindows){
            cb1.setState(true);
        }else{
            cb1.setState(false);
        }
        //CheckboxMenuItem cb2 = new CheckboxMenuItem("Auto Send Data to RDF");
        //Menu displayMenu = new Menu("Display");
        //MenuItem errorItem = new MenuItem("Error");
        //MenuItem warningItem = new MenuItem("Warning");
        //MenuItem infoItem = new MenuItem("Info");
        //MenuItem noneItem = new MenuItem("None");
        MenuItem exitItem = new MenuItem("Exit");

        //Add components to popup menu
        popup.add(aboutItem);
        popup.add(accountItem);
        popup.add(patientInfoItem);
        popup.addSeparator();
        popup.add(ecgFileItem);
        popup.add(ecgReportItem);
        popup.addSeparator();
        popup.add(ecgFileUploadItem);
        popup.addSeparator();
        popup.add(visualItem);
        popup.add(browseDBItem);
        popup.add(statsItem);
        popup.addSeparator();
        popup.add(cb1);
        //popup.add(cb2);
        popup.addSeparator();
        //popup.add(displayMenu);
        //displayMenu.add(errorItem);
        //displayMenu.add(warningItem);
        //displayMenu.add(infoItem);
        //displayMenu.add(noneItem);
        popup.add(exitItem);
        
       

        Finals.trayIcon.setPopupMenu(popup);

        try {
            tray.add(Finals.trayIcon);
        } catch (AWTException e) {
            System.out.println("TrayIcon could not be added.");
            //Ubuntu -> http://askubuntu.com/questions/30742/how-do-i-access-and-enable-more-icons-to-be-in-the-system-tray
            return;
        }

        
        aboutItem.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                if (ab == null) {
                    ab = new AboutJFrame();
                }
                RefineryUtilities.centerFrameOnScreen(ab);
                ab.setVisible(true);
            }
        });
        
        patientInfoItem.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                if (pb == null) {
                    pb = new PatientInfoJFrame();
                }
                RefineryUtilities.centerFrameOnScreen(pb);
                pb.setVisible(true);
            }
        });
        
        accountItem.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                if (su == null) {
                    su = new SetUserJFrame();
                }
                RefineryUtilities.centerFrameOnScreen(su);
                su.initiateValues();
                su.setVisible(true);
            }
        });
        
               

        ecgFileItem.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent ee) {
            	
                Thread AFibDetectorThread = new Thread() {
                    public void run() {
                    	                    	             	           	
        				JFileChooser chooser = new JFileChooser();
        				
        				FileFilter mFileFilter = new ExtensionFileFilter(new String[] { "edf" }, "edf");
        			    chooser.setFileFilter(mFileFilter);

        				int choice = chooser.showOpenDialog(chooser);
        				
        				if (choice != JFileChooser.APPROVE_OPTION) {
        					return;
        				}

        				File chosenFile = chooser.getSelectedFile();
        				
        		        if (chosenFile == null) {
        		            return;     	
        		        }
        		        else {
        		        	ecgFileItem.setEnabled(false);
                            ecgReportItem.setEnabled(false);
        		        }
        		        	
        		        String edfFilePath = chooser.getSelectedFile().getAbsolutePath();
        				
        		        AFibDetector(edfFilePath);
        		        
    		        	ecgFileItem.setEnabled(true);
                        ecgReportItem.setEnabled(true);
                    }
                  };
                  AFibDetectorThread.start();	
            }
        });
        
        // FTP file upload
        ecgFileUploadItem.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent ee) {
            	
                if (fu == null) {
                    fu = new FileUploadJFrame();
                }
                RefineryUtilities.centerFrameOnScreen(fu);
                fu.setVisible(true);
            	
                /*
                Thread FileUploadThread = new Thread() {
                    public void run() {
            	
                    	JFileChooser chooser = new JFileChooser();
				
                    	FileFilter mFileFilter = new ExtensionFileFilter(new String[] { "edf" }, "edf");
                    	chooser.setFileFilter(mFileFilter);

                    	int choice = chooser.showOpenDialog(chooser);
				
                    	if (choice != JFileChooser.APPROVE_OPTION) {
                    		return;
                    	}

                    	File chosenFile = chooser.getSelectedFile();
				
                    	if (chosenFile == null) {
                    		return;     	
                    	}
                    	else {
                    		ecgFileUploadItem.setEnabled(false);
                    	}
		        	
                    	String edfFilePath = chooser.getSelectedFile().getAbsolutePath();                 
                    	String edfFileName = chooser.getSelectedFile().getName();
                    	

                    	if (!AES.symmetricDecrypt(Finals.ftpIP, Finals.seed).isEmpty() && 
                    		!AES.symmetricDecrypt(Finals.ftpPort, Finals.seed).isEmpty() &&
                    		!AES.symmetricDecrypt(Finals.ftpUsername, Finals.seed).isEmpty() &&
                    		!AES.symmetricDecrypt(Finals.ftpPassword, Finals.seed).isEmpty() &&
                    		!AES.symmetricDecrypt(Finals.ftpUploadDir, Finals.seed).isEmpty()) {
                    		
                    		String ftpIpAddress = AES.symmetricDecrypt(Finals.ftpIP, Finals.seed);
                    		int	ftpPort = Integer.valueOf(AES.symmetricDecrypt(Finals.ftpPort, Finals.seed));
                    		String ftpUsername = AES.symmetricDecrypt(Finals.ftpUsername, Finals.seed);               
                    		String ftpPassword = AES.symmetricDecrypt(Finals.ftpPassword, Finals.seed);
                    		String uploadPath = AES.symmetricDecrypt(Finals.ftpUploadDir, Finals.seed);
                    	
                    		//String ftpIpAddress = "158.129.12.95";
                    		//int ftpPort = 21;
                    		//String ftpUsername = "Solo";                 
                    		//String ftpPassword = "8O*}YO";
                    		//String uploadPath = "/homes/Solo/Signals/ECGs/";
                            	
                    		System.out.println("Start");
                        
                    		boolean connectionError = false;
                        
                    		FTPUploader ftpUploader = null;
                    		try {
                    			ftpUploader = new FTPUploader(ftpIpAddress, ftpPort, ftpUsername, ftpPassword);	
                    		} catch (Exception e) {
                    			// TODO Auto-generated catch block
                    			connectionError = true;
                    			e.printStackTrace();
                    		}
						
                    			if (!connectionError) {
						
                    				boolean uploadDirExists = false;
                    				try {
                    					uploadDirExists = ftpUploader.checkDirectoryExists(uploadPath);
								
                    				} catch (IOException e2) {
                    					// TODO Auto-generated catch block
                    					e2.printStackTrace();
                    				}
						
                    					if (uploadDirExists) {
						
                    						boolean fileExists = false;
                    						try {
                    							fileExists = ftpUploader.checkFileExists(uploadPath + edfFileName);
							
                    						} catch (IOException e1) {
                    							// TODO Auto-generated catch block
                    							e1.printStackTrace();
                    						}
												
                    							if (!fileExists) {
						
                    								try {
                    									ftpUploader.uploadFile(edfFilePath, edfFileName, uploadPath);								
                    								} catch (Exception e) {
                    									// TODO Auto-generated catch block
                    									e.printStackTrace();
                    								}
                    								ftpUploader.disconnect();
                    								System.out.println("Done");
                    								Finals.trayIcon.displayMessage("ECG file", "was uploaded successfully!", TrayIcon.MessageType.INFO); 
                    							} else {       				
                    								Finals.trayIcon.displayMessage("ECG file", "is already available and was not uploaded again!", TrayIcon.MessageType.INFO); 
                    								ftpUploader.disconnect();
                    							}
							
                    					} else {							
                    						Finals.trayIcon.displayMessage("Specified upload directory", "does not exist, please check!", TrayIcon.MessageType.INFO); 
                    						ftpUploader.disconnect();
                    					}
                    					ecgFileUploadItem.setEnabled(true);
						
                    			} else {
                    				Finals.trayIcon.displayMessage("Connection error", "check FTP IP, port, username and password!", TrayIcon.MessageType.ERROR); 
                    				ecgFileUploadItem.setEnabled(true);
                    			}	
                    	} else {
                    		Finals.trayIcon.displayMessage("Set up FTP credentials", "go to Settings!", TrayIcon.MessageType.ERROR); 
                    		ecgFileUploadItem.setEnabled(true);
                    	}                    	
                    }                    
                  };
                  FileUploadThread.start();    
                  */
            }
             
        });
        
           
        ecgReportItem.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent ee) {
            	
            	
            	if (Desktop.isDesktopSupported()) {
            	    try {
            	        File myFile = new File(Finals.homeDir + "PatientReport.pdf");
            	        if (myFile.exists()) {
            	        	Desktop.getDesktop().open(myFile);
            	        }
            	    } catch (IOException ex) {
            	        // no application registered for PDFs
            	    }
            	}
            	
            }
        });
                
        

        browseDBItem.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                SwingUtilities.invokeLater(new Runnable() {
                    public void run() {
                        if (br == null) {
                            br = new DBBrowser();
                            br.createGUI(new File(Finals.dbURL), false, true);
                            br.showGui();
                        } else {
                            br.showGui();
                        }
                    }
                });
            }
        });

        visualItem.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                if (gb == null) {
                    gb = new GraphJFrame(db);
                }
                RefineryUtilities.centerFrameOnScreen(gb);
                gb.refreshResutls();
                gb.setVisible(true);
            }
        });
        
        statsItem.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                if (st == null) {
                    st = new StatisticsJFrame(db);
                }
                RefineryUtilities.centerFrameOnScreen(st);
                st.refreshResutls();
                st.setVisible(true);
            }
        });

        cb1.addItemListener(new ItemListener() {
            public void itemStateChanged(ItemEvent e) {
                int cb1Id = e.getStateChange();
                
                //TODO: 8elei kolpa edw sto telos
                if (cb1Id == ItemEvent.SELECTED) {
                    Finals.stWithWindows = true;
                    //trayIcon.setImageAutoSize(true);
                } else {
                    Finals.stWithWindows = false;
                    //trayIcon.setImageAutoSize(false);
                }
            }
        });


        exitItem.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                tray.remove(Finals.trayIcon);
                wServer.doStop();
		scheduler.shutdownNow();
                Finals.saveProperties();
                db.closeConnecion();
                System.exit(0);
            }
        });
    }
    

    
    public static void insertAllEpisodes(ArrayList<AFibEpisode> eps) {
        try {
            HttpAuthenticator authenticator = null;
            String username = "";
            boolean ok = true;
            int count = 0;
            for (AFibEpisode ep : eps) {

                    if (authenticator == null) {
                        username = AES.symmetricDecrypt(Finals.userCARRE, Finals.seed);
                        if(username.equals("")){
                        	Finals.trayIcon.displayMessage("Private RDF Account is required", "Please insert your account of your private RDF", TrayIcon.MessageType.INFO);
                        	ok = false;
                        	break;
                        }
                        authenticator = new SimpleAuthenticator(username, AES.symmetricDecrypt(Finals.passCARRE, Finals.seed).toCharArray());
                    }

                    int code = uploadAnEpisodeToPrivateRDFandReturnStatusCode(ep, authenticator, username);
                    if (code != 200 && code != 1000) {
                        String mesage = "General Unknown Error!\nStatus Code: " + code;
                        if (code == 401) {
                            mesage = "Error in user authentication!\nPlease check your account.";
                        } else if (code == 404) {
                            mesage = "File not found!\nError on URL of Endpoint.";
                        } else if (code == 500) {
                            mesage = "SPARQL request error!";
                        } else if (code == -1) {
                            mesage = "General networking error!";
                        } else if (code == -2) {
                            mesage = "General error!";
                        } 
                        Finals.trayIcon.displayMessage("Error in Uploading Episodes to RDF", mesage, TrayIcon.MessageType.ERROR);                    
                        Logger.getLogger(RDFSenderExecutionRunnable.class.getName()).log(Level.SEVERE, "Error in Uploading Episodes to RDF", mesage);
                        ok = false;
                        break;
                        //401 Unauthorized -> Error on username or password
                        //404 File not found -> Error on url endpoint
                        //500 SPARQL Request error
                        //-1 java.net.UnknownHostException -> network error    
                    }
                    else if (code == 1000) {
                    	Finals.trayIcon.displayMessage("Episodes to RDF", (eps.size() - count)+" / "+eps.size()+ " episodes already exist and are/is not uploaded to your private RDF!", TrayIcon.MessageType.INFO); 
                    	ok = false;
                    }
                    else{
                    	count++;
                    }
            }
            if(ok){
            	Finals.trayIcon.displayMessage("Episodes to RDF", count+" / "+eps.size()+ " episodes are/is successfully uploaded to your private RDF!", TrayIcon.MessageType.INFO); 
            	//System.out.println( eps.size()+ " episodes are/is successfully uploaded to your private RDF!");
            }
        } catch (Exception ex) {
            Logger.getLogger(TrayIconCarre.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
    
    
    public static void AFibDetector(String edfFilePath) {
    	
        // Set Patient info
        PatientInfo mPatientInfo = new PatientInfo();                   	            
        
        mPatientInfo.setPatientName(AES.symmetricDecrypt(Finals.CARREpatientName, Finals.seed));
        mPatientInfo.setPatientSurname(AES.symmetricDecrypt(Finals.CARREpatientSurname, Finals.seed));
        mPatientInfo.setPatientSex(AES.symmetricDecrypt(Finals.CARREpatientSex, Finals.seed));
        mPatientInfo.setPatientAge(AES.symmetricDecrypt(Finals.CARREpatientAge, Finals.seed));
        mPatientInfo.setPatientHeight(AES.symmetricDecrypt(Finals.CARREpatientHeight, Finals.seed));                        
        mPatientInfo.setPatientWeight(AES.symmetricDecrypt(Finals.CARREpatientWeight, Finals.seed));
        if (!AES.symmetricDecrypt(Finals.CARREpatientHeight, Finals.seed).isEmpty() && !AES.symmetricDecrypt(Finals.CARREpatientWeight, Finals.seed).isEmpty()) {
        mPatientInfo.setPatientBMI(Integer.toString((int) (Double.parseDouble(AES.symmetricDecrypt(Finals.CARREpatientWeight, Finals.seed)) / (Math.pow(Double.parseDouble(AES.symmetricDecrypt(Finals.CARREpatientHeight, Finals.seed)) / 100, 2))))); 
        }
        
    	mDigitalFilterECGhighPrep  = new DigitalFilter();
    	mDigitalFilterECGlowPrep   = new DigitalFilter();
    	mDigitalFilterECGnotchPrep = new DigitalFilter();
    	        
		mDigitalFilterECGhighProc  = new DigitalFilter();
		mDigitalFilterECGlowProc   = new DigitalFilter();
		mDigitalFilterECGintegProc = new DigitalFilter();
		
		mFilterCoefficients = new FilterCoefficients();
		
	    smooth = new MovingAverageFilter();
		
		// Create new AFib detector object
		mAFibDetector = new AFibDetector();
		        				
		mAFibParametrizationForRDF = new AFibParametrizationForRDF();
		mAFibParametrizationForReport = new AFibParametrizationForReport();
		mSinusRhythmParametrizationForReport = new SinusRhythmParametrizationForReport();
			
        //EDF file reading
		
		InputStream is = null;
		try {
			is = new BufferedInputStream(new FileInputStream(edfFilePath));
		} catch (FileNotFoundException e1) {
			e1.printStackTrace();
		}
		
		EDFParserResult result = null;
		try {
			result = EDFParser.parseEDF(is);
		} catch (EDFParserException e) {
			e.printStackTrace();
		}
		
		System.out.println("Signal name: " + result.getHeader().getSubjectID());
		System.out.println("Sampling frequency: " + result.getHeader().getNumberOfSamples()[0]);
		
		int SamplingFrequency = result.getHeader().getNumberOfSamples()[0];
		
		if (SamplingFrequency == 250 || SamplingFrequency == 2500 || SamplingFrequency == 500 || SamplingFrequency == 1000) {
		 				
			        int step = 0;
			        switch (SamplingFrequency) {
		            case 250:   step = 0;
		            		  break;
		            case 2500:  step = 0;
		                      break;
		            case 500:   step = 1;
		                      break;
		            case 1000:  step = 3;
		                      break;
		        }
			
		String dd = result.getHeader().getStartDate().substring(0, 2);
		String MM = result.getHeader().getStartDate().substring(3, 5);	
		String yy = result.getHeader().getStartDate().substring(6, 8);			
		String hh = result.getHeader().getStartTime().substring(0, 2);		
		String mm = result.getHeader().getStartTime().substring(3, 5);		
		String ss = result.getHeader().getStartTime().substring(6, 8);		
		
		String startTime;
		if (Integer.parseInt(yy) >=85)
			startTime = "19" + yy + '-' + MM + '-' + dd + "T" + hh + ':' + mm + ':' + ss + "Z";
		else
			startTime = "20" + yy + '-' + MM + '-' + dd + "T" + hh + ':' + mm + ':' + ss + "Z";

			
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss'Z'");
		Date ECGstartDate = null;
		try {
			ECGstartDate = sdf.parse(startTime);
		} catch (ParseException e) {
			e.printStackTrace();
		}
			
		System.out.println("ECG duration, s: " + result.getSignal().getValuesInUnits()[0].length / (step + 1) / Fs);

		double[] ECG      = new double[result.getSignal().getValuesInUnits()[0].length / (step + 1)];
		double[] ECGprep  = new double[result.getSignal().getValuesInUnits()[0].length / (step + 1)];
		double[] ECGproc  = new double[result.getSignal().getValuesInUnits()[0].length / (step + 1)];

		int k = -1;
		// ECG preprocessing
		for (int j = 0; j < result.getSignal().getValuesInUnits()[0].length; j = j + 1 + step)
		{	
			k++;
			ECG[k] = result.getSignal().getValuesInUnits()[0][j];
		    ECGprep[k] = mDigitalFilterECGhighPrep.IIRFilter(ECG[k],      mFilterCoefficients.b_ecg_high_250_prep,  mFilterCoefficients.a_ecg_high_250_prep);
		    ECGprep[k] = mDigitalFilterECGlowPrep.IIRFilter(ECGprep[k],   mFilterCoefficients.b_ecg_low_250_prep,   mFilterCoefficients.a_ecg_low_250_prep);
		    //ECGprep[k]= mDigitalFilterECGnotchPrep.IIRFilter(ECGprep[k], mFilterCoefficients.b_ecg_notch_250_60_prep, mFilterCoefficients.a_ecg_notch_250_60_prep);
		    ECGprep[k] = mDigitalFilterECGnotchPrep.IIRFilter(ECGprep[k], mFilterCoefficients.b_ecg_notch_250_50_prep, mFilterCoefficients.a_ecg_notch_250_50_prep);
		    
		    ECGproc[k] = mDigitalFilterECGhighProc.FIRFilter(ECGprep[k],  mFilterCoefficients.b_ecg_high_250);
		    ECGproc[k] = mDigitalFilterECGlowProc.FIRFilter(ECGproc[k],   mFilterCoefficients.b_ecg_low_250);
		    ECGproc[k] = Math.abs(ECGproc[k]);
		    ECGproc[k] = mDigitalFilterECGintegProc.FIRFilter(ECGproc[k], mFilterCoefficients.b_ecg_integ);
		    ECGproc[k] = smooth.Moving_Average_Filter(ECGproc[k], 20);
		}
		
		        				
		// ECG RR detector			  						
		double Pause = 0.16*Fs; 
		double ma1 = 0; 
		double ma = 0;
		int x = 0;
		for (int i = 1; i < 1*Fs; i++) {
		    if (ECGproc[i - 1] < ECGproc[i]) {
		        ma = ECGproc[i];
		        if (ma > ma1) {     
		            ma1 = ma;   
		            x = i;     
		        }
		    }
		}


		ArrayList<Integer> R_idx_L = new ArrayList<Integer>();
		ArrayList<Integer> R_idx_H = new ArrayList<Integer>();
		
		double H_threshold = ma1 / 3; // didesnysis slenkstis
		double L_threshold = ma1 / 5; // mazesnysis slenkstis
		int i = x;  //  first R
		R_idx_H.add(x); // R found with high threshold
		R_idx_L.add(x); // R found with small threshold
		boolean Found = true;

		ArrayList<Double> RRI = new ArrayList<Double>();
		
		while (i < (ECGproc.length - Pause - 1)) {
	    if (Found) {                                  // is R found?  
	        i = i + (int) Pause;                      // pause for 0.15s
	    }
	    Found = false;                    			  // where is the end of the interval?
	    if (ECGproc[i] > L_threshold) {       			  // is the sample > 1/4ma ?(smaler threshold)
	        if (ECGproc[i - 1] < ECGproc[i]) {      // is former sample less than present?
	            ma = ECGproc[i];                     // yes, new maxima 
	            x=i;                                  // yes, new index i
	        }
	        else {                      			  // no
	            R_idx_L.add(x);  	                  // ne, isimename R danteliu, rastu pagal mazesnyji slenksti, indeksa
	            L_threshold = ma / 5;                 // decreasing threshold
	        }
	        if (ECGproc[i] > H_threshold) {          // is present sample > 1/2ma (comparison with higher threshold)
	            if (ECGproc[i-1] < ECGproc[i]) {    // is former sample less than present?
	                ma = ECGproc[i];                 // yes, new maxima 
	                x=i;                              // yes, new index i
	            }
	            else {
	                R_idx_H.add(x);               
	                H_threshold = ma / 3;             // no, decrease the threshold
	                Found = true;                     // new R is found
	                RRI.add((R_idx_H.get(R_idx_H.size() - 1) - R_idx_H.get(R_idx_H.size() - 2)) * (1 / Fs)); //               
	                
	                // Outlier removal
	                if (RRI.size() > 0) {
	                	if ((1 / RRI.get(RRI.size() - 1)) * 60 > 280) {
	                		RRI.remove(RRI.size() - 1);
	                		R_idx_H.remove(R_idx_H.size() - 1);
	                	}
	                	else if ((1 / RRI.get(RRI.size() - 1)) * 60 < 20) {
	                		RRI.remove(RRI.size() - 1);
	                		R_idx_H.remove(R_idx_H.size() - 1);
	                	}
	                }
	                
	                
	            }
	        }
	    }
	    
	    i++; 
	}
		
	
	
	if (!RRI.isEmpty()) {
	
		int[] PeaksArray = ListToIntegerArray(R_idx_H);	
		double[] rrm = ListToDoubleArray(RRI);
		       				
		// AFib detector, returns decision array.
		double[] AFibDetectorOut = mAFibDetector.func_detectAF(rrm);
			
		// AFib parameters, returns AFib episode start, episode duration, mean heart rate of the episode.
		insertAllEpisodes(mAFibParametrizationForRDF.AFibParameters(Fs, ECGprep, AFibDetectorOut, PeaksArray, rrm, ECGstartDate));
		
		mPDFreport = new PDFreport();
		boolean reportIsGenerated = mPDFreport.generatePDFreport(mPatientInfo, mAFibParametrizationForReport.AFibParameters(Fs, ECGprep, AFibDetectorOut, PeaksArray, rrm, ECGstartDate), 
				                                                 mSinusRhythmParametrizationForReport.SinusRhythmParameters(Fs, ECGprep, AFibDetectorOut, PeaksArray, rrm, ECGstartDate));
		
		if (reportIsGenerated) {
			ecgFileItem.setEnabled(true);
			ecgReportItem.setEnabled(true);
			Finals.trayIcon.displayMessage("ECG analysis report", "is prepared!", TrayIcon.MessageType.INFO); 
		}
		
		R_idx_L.clear();	
		R_idx_H.clear();
		RRI.clear();
		
    	}
		else {
			ecgFileItem.setEnabled(true);
			ecgReportItem.setEnabled(true);
			Finals.trayIcon.displayMessage("No ECG RR intervals detected", "try another signal!", TrayIcon.MessageType.INFO);		
		}
	  }
		else {
			ecgFileItem.setEnabled(true);
			ecgReportItem.setEnabled(true);
			Finals.trayIcon.displayMessage("Incorrect ECG sampling frequency of " + SamplingFrequency + " Hz", "try another signal or change FAROS sampling frequency to 250, 500 or 1000 Hz", TrayIcon.MessageType.INFO);	
		}
    }		

	static int[] ListToIntegerArray(ArrayList<Integer> arrayList) {
    	int[] DoubleArray = new int[arrayList.size()];
		for (int i = 0; i < arrayList.size(); i++) {
			
			DoubleArray[i] = arrayList.get(i);
		}
		return DoubleArray; 
    }
    
	static double[] ListToDoubleArray(ArrayList<Double> arrayList) {
    	double[] DoubleArray = new double[arrayList.size()];
		for (int i = 0; i < arrayList.size(); i++) {
			
			DoubleArray[i] = (double) arrayList.get(i);
		}
		return DoubleArray;
    }
    
	

	
	
    public static int uploadAnEpisodeToPrivateRDFandReturnStatusCode(AFibEpisode ep, HttpAuthenticator authenticator, String username) {

//      SELECT ?x FROM <https://carre.kmi.open.ac.uk/users/Andrius> WHERE {
//    	?x <http://carre.kmi.open.ac.uk/ontology/sensors.owl#is_measured_by> <http://carre.kmi.open.ac.uk/manufacturers/emotion> .
//    	?x <http://carre.kmi.open.ac.uk/ontology/sensors.owl#has_date> ?y .
//    	?y <http://carre.kmi.open.ac.uk/ontology/sensors.owl#has_value> "2014-12-02T02:12:15Z"^^<http://www.w3.org/2001/XMLSchema#datetime> .
//    	}     
    	
    	Query queryCheck = QueryFactory.create("SELECT ?s FROM <"+Finals.urlPrivateIRI + username+"> WHERE { ?s <"+Finals.urlOWLecg+"#is_measured_by> <http://carre.kmi.open.ac.uk/manufacturers/emotion> ."
    												+ "?s <http://carre.kmi.open.ac.uk/ontology/sensors.owl#has_date> ?p . "
    												+ "?p <http://carre.kmi.open.ac.uk/ontology/sensors.owl#has_value> \""+ep.AFstartTime+"\"^^<http://www.w3.org/2001/XMLSchema#datetime> .}");
        QueryExecution qexecCheck = QueryExecutionFactory.sparqlService(Finals.urlPrivateRDF, queryCheck, authenticator); //\""+ep.heartRate+"\"  \""+2014-12-02T02:12:15Z+"\" \""+ep.startTime+"\" \""+"2014-12-02T02:12:15Z"+"\"
        ResultSet resultsCheck = null;
        boolean EnterNewData = false;
        try{
        	resultsCheck = qexecCheck.execSelect();

            if (resultsCheck.hasNext()) {
            	//System.out.println("RDF repository contains this entry"); 
            	EnterNewData = false;}
            else {
            	//System.out.println("RDF repository does not contain this entry");
            	EnterNewData = true;}
        	
        } catch (HttpException he) {
            return he.getResponseCode();
            //401 Unauthorized -> Error on username or password
            //404 File not found -> Error on url endpoint
            //500 SPARQL Request error
            //-1 java.net.UnknownHostException -> network error            
        } catch (Exception ee) {
            Logger.getLogger(RDFSenderExecutionRunnable.class.getName()).log(Level.SEVERE, null, ee);
            return -2;
        }
       
        // Display query result
        //ResultSetFormatter.out(System.out, resultsCheck, queryCheck);
        
        qexecCheck.close();
        
        if (EnterNewData) {
    	
        Query query = QueryFactory.create("SELECT ?s FROM <"+Finals.urlPrivateIRI + username+"> WHERE { ?s <"+Finals.urlOWLecg+"#has_connection> <"+Finals.urlPrivateIRI + username+"/connections/"+Finals.appUUID+"> }");
        QueryExecution qexec = QueryExecutionFactory.sparqlService(Finals.urlPrivateRDF, query, authenticator);
        ResultSet results = null;
        try{
            results = qexec.execSelect();
        } catch (HttpException he) {
            return he.getResponseCode();
            //401 Unauthorized -> Error on username or password
            //404 File not found -> Error on url endpoint
            //500 SPARQL Request error
            //-1 java.net.UnknownHostException -> network error            
        } catch (Exception ee) {
            Logger.getLogger(RDFSenderExecutionRunnable.class.getName()).log(Level.SEVERE, null, ee);
            return -2;
        }    
               
        if (results != null && !results.hasNext()) {
                try {
            UpdateRequest request1 = UpdateFactory.create("INSERT DATA { GRAPH <" + Finals.urlPrivateIRI + username + "> { "
                    + "<"+Finals.urlPrivateIRI + username+">  <"+Finals.urlOWLecg+"#has_connection>  <"+Finals.urlPrivateIRI + username+"/connections/"+Finals.appUUID+"> . "
                    + "<"+Finals.urlPrivateIRI + username+"/connections/"+Finals.appUUID+">  <"+Finals.urlOWLecg+"#has_manufacturer>  <http://carre.kmi.open.ac.uk/manufacturers/emotion> "
                    + "} }");
            UpdateProcessor proc = UpdateExecutionFactory.createRemoteForm(request1, Finals.urlPrivateRDF, authenticator);
            try {
                proc.execute();
            } catch (HttpException he) {
                return he.getResponseCode();
                //401 Unauthorized -> Error on username or password
                //404 File not found -> Error on url endpoint
                //500 SPARQL Request error
                //-1 java.net.UnknownHostException -> network error            
            } catch (Exception ee) {
                Logger.getLogger(TrayIconCarre.class.getName()).log(Level.SEVERE, null, ee);
                return -2;
            }

        } catch (QueryParseException qpe) {
            Logger.getLogger(TrayIconCarre.class.getName()).log(Level.SEVERE, null, qpe);
            return -2;
        }            
        }
        qexec.close();
        
        
        
        try {
            String uuid = UUID.randomUUID().toString();
               
            
            String insert = "INSERT DATA { GRAPH <" + Finals.urlPrivateIRI + username + "> { "
                    + "\n<"+Finals.urlPrivateIRI + username+"/measurements/"+uuid+">  <"+Finals.urlOWLecg+"#has_date>  <"+Finals.urlPrivateIRI + username+"/measurements/"+uuid+"_date> . "
                    + "\n<"+Finals.urlPrivateIRI + username+"/measurements/"+uuid+"_date>  <"+Finals.urlOWLecg+"#has_value>  \""+ep.AFstartTime+"\"^^<http://www.w3.org/2001/XMLSchema#datetime> . "
                    + "\n<"+Finals.urlPrivateIRI + username+"/measurements/"+uuid+">  <"+Finals.urlOWLecg+"#has_duration>  <"+Finals.urlPrivateIRI + username+"/measurements/"+uuid+"_duration> . "
                    + "\n<"+Finals.urlPrivateIRI + username+"/measurements/"+uuid+"_duration>  <"+Finals.urlOWLecg+"#has_value>  \""+ep.AFduration+"\"^^<http://www.w3.org/2001/XMLSchema#long> . "
                    + "\n<"+Finals.urlPrivateIRI + username+"/measurements/"+uuid+">  <"+Finals.urlOWLecg+"#has_heartrate>  <"+Finals.urlPrivateIRI + username+"/measurements/"+uuid+"_heartrate> . "
                    + "\n<"+Finals.urlPrivateIRI + username+"/measurements/"+uuid+"_heartrate>  <"+Finals.urlOWLecg+"#has_value>  \""+ep.AFheartRate+"\"^^<http://www.w3.org/2001/XMLSchema#integer> . "
                    + "\n<"+Finals.urlPrivateIRI + username+"/measurements/"+uuid+">  <"+Finals.urlOWLecg+"#is_measured_by>  <http://carre.kmi.open.ac.uk/manufacturers/emotion>"
                    + "} }";
            
            UpdateRequest request1 = UpdateFactory.create(insert);
            UpdateProcessor proc = UpdateExecutionFactory.createRemoteForm(request1, Finals.urlPrivateRDF, authenticator);
            
            try {
                proc.execute();
                return 200;
            } catch (HttpException he) {
                return he.getResponseCode();
                //401 Unauthorized -> Error on username or password
                //404 File not found -> Error on url endpoint
                //500 SPARQL Request error
                //-1 java.net.UnknownHostException -> network error            
            } catch (Exception ee) {
                Logger.getLogger(RDFSenderExecutionRunnable.class.getName()).log(Level.SEVERE, null, ee);
                return -2;
            }
        
        } 
        catch (QueryParseException qpe) {
            Logger.getLogger(RDFSenderExecutionRunnable.class.getName()).log(Level.SEVERE, null, qpe);
            return -2;
        }
        
        }
		return 1000;
    }

}
