package scheduler;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;

public class FixedExecutionRunnable implements Runnable {
    private final Runnable delegate;
    private volatile ScheduledFuture<?> self;
    private final Date Stop;

    public FixedExecutionRunnable(Runnable delegate, Date stop) {
        this.delegate = delegate;
        this.Stop = stop;
    }

    public void run() {
        if((new Date()).after(this.Stop)) {
            self.cancel(false);
        }else{
            delegate.run();
        }
    }

    public void runAtAFixedPeriod(ScheduledExecutorService executor, Date start, long period) {
	long initialdelay = (start.getTime() - (new Date()).getTime())/1000; 
        self = executor.scheduleAtFixedRate(this, initialdelay, period, TimeUnit.SECONDS);
    }
}
