/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package sqlite;

import com.google.gson.JsonObject;
import com.google.gson.JsonParser;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import org.supercsv.cellprocessor.Optional;
import org.supercsv.cellprocessor.ParseInt;
import org.supercsv.cellprocessor.constraint.NotNull;
import org.supercsv.cellprocessor.ift.CellProcessor;
import org.supercsv.io.CsvListReader;
import org.supercsv.io.ICsvListReader;
import org.supercsv.prefs.CsvPreference;
import sqlite.MySQLiteHelper;
import sqlite.dataSources.Categorization;

/**
 *
 * @author drosatosgr
 */
public class CategoryDataSource {

    MySQLiteHelper db;

    public CategoryDataSource(MySQLiteHelper db) {
        this.db = db;
    }

    public boolean insertNewCategory(Integer _id, String name, String desc, Integer parent_id, Integer forUploading) {
        String sql = "INSERT INTO " + MySQLiteHelper.TABLE_CATEGORY + " (" + MySQLiteHelper.CATEGORY_COLUMN_ID + "," + MySQLiteHelper.CATEGORY_COLUMN_NAME + "," + MySQLiteHelper.CATEGORY_COLUMN_DESCRIPTION + "," + MySQLiteHelper.CATEGORY_COLUMN_PARENT_ID + "," + MySQLiteHelper.CATEGORY_COLUMN_FOR_UPLOADING + ") VALUES (?, ?, ?, ?, ?);";
        return db.insert(sql, new Object[]{_id, name, desc, parent_id, forUploading});
    }

    public HashSet<Integer> getCategoriesIDsForUploading() {
        HashSet<Integer> ret = new HashSet<Integer>();
        try {
            ResultSet rs = db.select("SELECT "+MySQLiteHelper.CATEGORY_COLUMN_ID+" FROM " + MySQLiteHelper.TABLE_CATEGORY + " WHERE " + MySQLiteHelper.CATEGORY_COLUMN_FOR_UPLOADING + "=?;", new Object[]{1});
            if (rs != null) {
                while (rs.next()) {
                    ret.add(rs.getInt(1));
                }
                rs.close();
            }
        } catch (SQLException se) {
            Logger.getLogger(CategorizationDataSource.class.getName()).log(Level.SEVERE, null, se);
        }
        return ret;
    }
    
    public void loadCategoriesFromCSV(String file) {
        try {
            //CsvPreference SPACE_DELIMITED = new CsvPreference.Builder('"', ' ', "\r\n").build();
            CsvPreference STANDARD_PREFERENCE = new CsvPreference.Builder('"', ';', "\r\n").build();
            ICsvListReader inFile = new CsvListReader(new FileReader(file), STANDARD_PREFERENCE /*CsvPreference.STANDARD_PREFERENCE*/);
            final CellProcessor[] processors = new CellProcessor[]{
                new NotNull(new ParseInt()), //_id
                new NotNull(), // name
                new Optional(), // description
                new Optional(new ParseInt()), //parent_id
                new Optional(new ParseInt()), //forUploading
            };

            String[] header = inFile.getHeader(true);
            List<Object> customerList;
            while ((customerList = inFile.read(processors)) != null) {

                Integer _id = (Integer) customerList.get(0);
                String name = (String) customerList.get(1);
                String desc = (String) customerList.get(2);
                Integer parent_id = (Integer) customerList.get(3);
                Integer forUploading = (Integer) customerList.get(4);
                
                insertNewCategory(_id,name,desc,parent_id, forUploading);
            }

            inFile.close();

        } catch (FileNotFoundException ex) {
            Logger.getLogger(CategoryDataSource.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IOException ex) {
            Logger.getLogger(CategoryDataSource.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

}
