package usb.drive.checker;

import java.io.File;
import java.util.Arrays;

import javax.swing.filechooser.FileSystemView;


public final class DriveChecker {
    private static boolean[] drivers = new boolean[26];

    private static String driveDir;
    
    public DriveChecker(String driveDir) {
		super();
		DriveChecker.driveDir = driveDir;
	}

    public static boolean checkForDrive(String dir) {
        return new File(dir).exists();
    }
    
    public static void updateDriveInfo() {
        for (int i = 0; i < 26; i++) {
            drivers[i] = checkForDrive((char) (i + 'A') + ":/");      
        }
    }

    public static boolean newDriveDetected() {
        for (int i = 0; i < 26; i++) {
        	String dir = ((char) (i + 'A') + ":/");
            if (!drivers[i] && checkForDrive(dir)) {
            	
            	FileSystemView view = FileSystemView.getFileSystemView();
            	File directory = new File(dir);
            	String deviceName = view.getSystemDisplayName(directory);
            	
            	if(deviceName.contains(" ")){
            		deviceName = deviceName.substring(0, deviceName.indexOf(" ")); 
            	}
            	
            	if (deviceName.equals("FAROS_DATA")) {
            		DriveChecker.setDriveDir(dir);
            		//System.out.println(dir);
                return true;
            	}
            }
        }
        return false;
    }
    
    /*
    public static boolean newDriveDetected() {
        for (int i = 0; i < 26; i++) {
        	String dir = ((char) (i + 'A') + ":/");
            if (!drivers[i] && checkForDrive(dir)) {           	      	
            	DriveChecker.setDriveDir(dir);
                return true;
            }
        }
        return false;
    }
    */

    public static boolean driveRemoved() {
        for (int i = 0; i < 26; i++) {
        	String dir = ((char) (i + 'A') + ":/");
            if (drivers[i] && !checkForDrive(dir)) {
            	DriveChecker.setDriveDir(dir);
                return true;
            }
        }
        return false;
    }
    
    public static boolean drivesChangedSinceLastUpdate() {
        for (int i = 0; i < 26; i++) {
            if (drivers[i] != checkForDrive((char) (i + 'A') + ":/")) {
                return true;
            }
        }
        return false;
    }

    public static void printInfo() {
        for (int i = 0; i < 26; i++) {
            System.out.println("Driver " + (char) (i + 'A') + ":/ "
                    + (drivers[i] ? "exists" : "does not exist"));
        }
    }
	
	public static String getDriveDir() {
		return driveDir;
	}
	
	public static void setDriveDir(String driveDir) {
		DriveChecker.driveDir = driveDir;
	}
	



}