package webserver;

import java.io.IOException;
import java.net.InetSocketAddress;
import java.util.concurrent.Executors;

import com.sun.net.httpserver.HttpServer;
import finals.Finals;
import java.net.InetAddress;
import java.net.UnknownHostException;
import java.util.logging.Level;
import java.util.logging.Logger;
import sqlite.MySQLiteHelper;

public class WServer implements Runnable {

    public final static int webServerListenerPort = Finals.webServerListenerPort;
    public final static String webServerListenerHost = Finals.webServerListenerHost;
    public final static String webServerPathAPI = Finals.webServerPathAPI;

    InetSocketAddress addr;
    HttpServer server;
    MySQLiteHelper db;

    public WServer(MySQLiteHelper db) {
        this.db = db;
        try {
            addr = new InetSocketAddress(InetAddress.getByName(webServerListenerHost), webServerListenerPort);
        } catch (UnknownHostException ex) {
            Logger.getLogger(WServer.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    public void doStop() {
        //Logger.getLogger(WServer.class.getName()).log(Level.INFO, "Web Server stopping");
        server.stop(0);
        Logger.getLogger(WServer.class.getName()).log(Level.INFO, "Web Server stoped");
    }

    public void run() {
        try {
            server = HttpServer.create(addr, 0);
            server.createContext("/", new RedirectHandler(webServerPathAPI));
            server.createContext(webServerPathAPI, new WebServerHandler(db));
            server.setExecutor(Executors.newCachedThreadPool());
            server.start();
            Logger.getLogger(WServer.class.getName()).log(Level.INFO, "Web Server starting on port: " + webServerListenerPort);
        } catch (IOException e) {
            Logger.getLogger(WServer.class.getName()).log(Level.SEVERE, null, e);
        }
    }

}
